unit im_G32skewFRM;
  {Transform_Ex.dpr}
interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  GR32, GR32_Transforms, GR32_Layers,
  GR32_ByteMaps, GR32_Blend,
  GR32_Image, GR32_RangeBars,
  ExtCtrls, StdCtrls, Buttons,
  PNGImage,
  Math,  ComCtrls, Grids, Menus;

type
  TOpType = (opNone, opTranslate, opScale, opRotate, opSkew);
  TOpRec = record
    OpType: TOpType;
    // shifts for opTranslate mode
    Dx, Dy: Extended;
     // scale factors for opScale mode
    Sx, Sy: Extended;
    // rotation center and angle (deg) for opRotate mode
    Cx, Cy, Alpha: Extended;
     // skew factors for opSkew mode
    Fx, Fy: Extended;
  end;
  TOpRecs = array[0..7] of TOpRec;

const
  OpTypes: array [0..4] of TOpType =
          (opNone, opTranslate, opScale, opRotate, opSkew);

type
  TTransformMode = (tmAffine, tmProjective, tmBilinear);

  TAG32SkewForm = class(TForm)
    ImgViewMenu: TMainMenu;
    MenuItem1: TMenuItem;
    mnFileOpen: TMenuItem;
    mnSave: TMenuItem;
    N1: TMenuItem;
    ExitAssign1: TMenuItem;
    Exit1: TMenuItem;
    mnLayers: TMenuItem;
    mnNewBitmapLayer: TMenuItem;
    mnBringFront: TMenuItem;
    mnSendBack: TMenuItem;
    Help1: TMenuItem;
    SavePictureDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    N2: TMenuItem;
    mnFlatten: TMenuItem;
    N3: TMenuItem;
    uponelevel1: TMenuItem;
    downonelevel1: TMenuItem;
    Panel4: TPanel;
    Panel3: TPanel;
    HelpBtn: TSpeedButton;
    Label20: TLabel;
    OpacityBar: TGaugeBar;
    LayerOpacity: TGaugeBar;
    LayerInterpolate: TCheckBox;
    Panel5: TPanel;
    aScrollBox1: TScrollBox;
    Src: TImage32;
    ScrollBox1: TScrollBox;
    Dst: TImage32;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    Panel6: TPanel;
    PageControl1: TPageControl;
    AffineTS: TTabSheet;
    Label9: TLabel;
    Label10: TLabel;
    Panel2: TPanel;
    Shape1: TShape;
    Shape2: TShape;
    StringGrid: TStringGrid;
    ListBox: TListBox;
    Button1: TButton;
    CodeString: TEdit;
    Panel1: TPanel;
    Label1: TLabel;
    ComboBox: TComboBox;
    Notebook: TNotebook;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    eDx: TEdit;
    eDy: TEdit;
    sbDx: TGaugeBar;
    sbDy: TGaugeBar;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    eSy: TEdit;
    eSx: TEdit;
    sbSx: TGaugeBar;
    sbSy: TGaugeBar;
    Label11: TLabel;
    Label13: TLabel;
    Label16: TLabel;
    Label15: TLabel;
    eCx: TEdit;
    eAlpha: TEdit;
    eCy: TEdit;
    sbAlpha: TGaugeBar;
    Label12: TLabel;
    Label14: TLabel;
    Label17: TLabel;
    eFx: TEdit;
    eFy: TEdit;
    sbFx: TGaugeBar;
    sbFy: TGaugeBar;
    RadioGroup1: TRadioGroup;
    ProjectiveTS: TTabSheet;
    Label18: TLabel;
    Label19: TLabel;
    Label21: TLabel;
    Splitter3: TSplitter;
    BackgroundCheckerboard1: TMenuItem;
    ExitBitmapBtn: TButton;
    ExitOnlyBtn: TButton;
    procedure FormCreate(Sender: TObject);
procedure CreateNewImage;


    procedure FormDestroy(Sender: TObject);
    procedure ListBoxClick(Sender: TObject);
    procedure ComboBoxChange(Sender: TObject);
    procedure TranslationChanged(Sender: TObject);
    procedure ScaleChanged(Sender: TObject);
    procedure TranslationScrolled(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ScaleScrolled(Sender: TObject);
    procedure RotationChanged(Sender: TObject);
    procedure RotationScrolled(Sender: TObject);
    procedure SkewChanged(Sender: TObject);
    procedure SkewScrolled(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure OpacityChange(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);

    procedure RubberLayerMouseDown(Sender: TObject;
      Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure RubberLayerMouseMove(Sender: TObject;
    Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure RubberLayerMouseUp(Sender: TObject;
      Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);

    procedure AppEventsIdle(Sender: TObject; var Done: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
    procedure mnSaveClick(Sender: TObject);
    procedure mnFileOpenClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure LayerOpacityChange(Sender: TObject);
    procedure mnFlattenClick(Sender: TObject);
    procedure LayerInterpolateClick(Sender: TObject);
    procedure mnBringFrontClick(Sender: TObject);
    procedure mnNewBitmapLayerClick(Sender: TObject);
    procedure BackgroundCheckerboard1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure ExitAssign1Click(Sender: TObject);
{    procedure mnNewBitmapLayerClick(Sender: TObject);
    procedure mnBringFrontClick(Sender: TObject);
}
  private
    { Private declarations }
    {ImgView}
    FSelection: TPositionedLayer;
    procedure SetSelection(Value: TPositionedLayer);
  protected
    BackgroundTiledOn,
    LoadingValues: Boolean;
    DraggedVertex: Integer;
    LastMousePos: TPoint;
    StippleStart: Single;
    procedure PaintHandles(Sender: TObject; BackBuffer: TBitmap32);
    function CreatePositionedLayer: TPositionedLayer;
    procedure LayerMouseDown(Sender: TObject; Buttons: TMouseButton; Shift: TShiftState; X, Y: Integer);

  public
    MagnifierOn,
    MouseDragging: Boolean;
    Operation: TOpRecs;
    Current: ^TOpRec;
    AT: TAffineTransformation;
    PT: TProjectiveTransformation;
    TT: TTransformation;
    Vertices: array[0..3] of TPoint;
    Mode: TTransformMode;
    property Selection: TPositionedLayer read FSelection write SetSelection;

    procedure ClearTransformations;
    procedure DoTransform;
    procedure GenTransform;
    procedure PrepareSource;
    procedure ShowSettings(OperationNum: Integer);
    procedure InitVertices; // for projective mapping
  end;

var
  AG32SkewForm: TAG32SkewForm;

implementation
uses  im_D5;
{uses  TongGlobals, TongsFrm;}

function GetVal(Src: string; var Dst: Extended): Boolean;
var
  Code: Integer;
begin
  Val(Src, Dst, Code);
  Result := Code = 0;
end;

{$R *.DFM}

procedure TAG32SkewForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(11000);
end;

procedure TAG32SkewForm.Exit1Click(Sender: TObject);
begin
   ExitOnlyBtn.Click;
end;                       
procedure TAG32SkewForm.ExitAssign1Click(Sender: TObject);
begin
  ExitBitmapBtn.Click;
end;
procedure TAG32SkewForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  AG32SkewFormX := AG32SkewForm.left;
  AG32SkewFormY:= AG32SkewForm.top;
  {AG32SkewForm.ModalResult:=mrOk;
  Close;

  AG32SkewForm.ModalResult:=mrCancel;
  Close;  }
 { TongsForm.Image1.Picture.Bitmap.Assign(Dst.Bitmap);
  TongsForm.SetFormCaption;
  Application.ProcessMessages;
   AG32SkewForm.ModalResult:=mrOk;
  Close;}
end;

procedure TAG32SkewForm.mnSaveClick(Sender: TObject);
var
  PNG: TPNGObject;
  Bitmap: TBitmap;
begin
  if not Dst.Bitmap.Empty then
  begin
    SavePictureDialog1.DefaultExt:='.png';
    SavePictureDialog1.Filter:='*.png';
    SavePictureDialog1.InitialDir:=ImagePath;
    SavePictureDialog1.Filename:= ChangeFileExt(ImagePath+OpenDialog1.FileName,'.png');{ImagePath+TempName}
    If SavePictureDialog1.Execute then
    begin
      Application.ProcessMessages;
      If (lowercase(ExtractFileExt(SavePictureDialog1.FileName))='.png') then
      begin
        PNG := TPNGObject.Create;
        Bitmap := TBitmap.Create;
        try
          Bitmap.Assign(Dst.Bitmap);
          PNG.Assign(Bitmap);
          PNG.SaveToFile(ChangeFileExt(SavePictureDialog1.FileName, '.png'));
        finally
          Bitmap.Free;
          PNG.Free;
        end;
      end;
    end;
  end;
end;

procedure TAG32SkewForm.mnFileOpenClick(Sender: TObject);
begin
  OpenDialog1.Filter:=
  'All (*.png;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf)|*.png;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf'+
    '|Portable Network Graphics (*.png)|*.png|JPEG Image File (*.jpg)|*.jpg|JPEG Image File (*.jpeg)|*.jpeg|Bitmaps (*.bmp)|*.bmp|Icons (*.ico)|*.ico|Enhanced Metafiles (*.emf)|*.emf|Metafiles (*.wmf)|*.wmf|Morph List Text|*.mlt';
  OpenDialog1.InitialDir:=ImagePath;
  //OpenDialog1.FileName:=TempName;
  if OpenDialog1.Execute then
  begin
    Src.Bitmap.LoadFromFile(OpenDialog1.FileName);
    CreateNewImage;
  end;
end;

procedure TAG32SkewForm.FormCreate(Sender: TObject);
begin
  left := AG32SkewFormX;
  top := AG32SkewFormY;
  BackgroundTiledOn:=True;
  CreateNewImage;
End;

procedure TAG32SkewForm.CreateNewImage;
Begin
  with Dst do
  begin
    Selection := nil;
    {RBLayer := nil;}
    Layers.Clear;
    Scale := 1;
  end;
  Dst.Bitmap.SetSize(Src.Bitmap.Width,
                     Src.Bitmap.Height);
  with TCustomLayer.Create(Dst.Layers) do
  begin
    OnPaint := PaintHandles;
  end;
  DraggedVertex := -1;
   // set the destination bitmap size to match the image size
  Dst.SetupBitmap;
  PrepareSource;
  ClearTransformations;
  ShowSettings(0);
  AT := TAffineTransformation.Create;
  PT := TProjectiveTransformation.Create;
  TT := AT;
  DoTransform;
end;

procedure TAG32SkewForm.ClearTransformations;
var
  I: Integer;
begin
  FillChar(Operation[0], SizeOf(TOpRecs), 0);
  for I := 0 to 7 do
  begin
    Operation[I].Sx := 1;
    Operation[I].Sy := 1;
    Operation[I].Cx := Src.Bitmap.Width / 2;
    Operation[I].Cy := Src.Bitmap.Height / 2;
  end;
end;

procedure TAG32SkewForm.PrepareSource;
begin
  // make the border pixels transparent
  // while keeping their RGB components
  SetBorderTransparent(Src.Bitmap,
    Rect(0, 0, Src.Bitmap.Width - 1, Src.Bitmap.Height - 1));
end;

procedure TAG32SkewForm.DoTransform;
var
  i, j: Integer;
  P: PColor32;
begin
  Application.ProcessMessages;
  GenTransform;
  Dst.BeginUpdate;

  // Fill Dst with checkerboard pattern
  P := Dst.Bitmap.PixelPtr[0, 0];
  for j := 0 to Dst.Bitmap.Height - 1 do
    for i := 0 to Dst.Bitmap.Width - 1 do
    begin
  If BackgroundTiledOn then
  begin
      if Odd(i shr 4) = Odd(j shr 4) then P^ := clGray32
      else P^ := clWhite32;
  end else P^ := clWhite32;
      Inc(P);
    end;

  Transform(Dst.Bitmap, Src.Bitmap, TT);
  Dst.EndUpdate;
  Dst.Repaint;

  if Mode = tmAffine then
  begin
    // fill the string grid
    for j := 0 to 2 do
      for i := 0 to 2 do
        StringGrid.Cells[i, j] := Format('%.3g', [AT.Matrix[i, j]]);
    StringGrid.Col := 3; // hide grid cursor
  end;
end;

procedure TAG32SkewForm.GenTransform;
var
  I: Integer;
  Rec: TOpRec;
  S: string;
begin
  TT.SrcRect := FloatRect(0, 0, Src.Bitmap.Width - 1,
                                Src.Bitmap.Height - 1);
  if Mode = tmAffine then
  begin
    // affine mode
    AT.Clear;
    for I := 0 to 7 do
    begin
      Rec := Operation[I];
      case Rec.OpType of
        opTranslate:  AT.Translate(Rec.Dx, Rec.Dy);
        opScale:      AT.Scale(Rec.Sx, Rec.Sy);
        opRotate:     AT.Rotate(Rec.Cx, Rec.Cy, Rec.Alpha);
        opSkew:       AT.Skew(Rec.Fx, Rec.Fy);
      end;
      case Rec.OpType of
        opTranslate:
        s := s + Format('Translate(%.3g, %.3g); ', [Rec.Dx, Rec.Dy]);
        opScale:
        s := s + Format('Scale(%.3g, %.3g); ', [Rec.Sx, Rec.Sy]);
        opRotate:
        s := s + Format('Rotate(%.3g, %.3g, %3g); ',
                         [Rec.Cx, Rec.Cy, Rec.Alpha]);
        opSkew:
        s := s + Format('Skew(%.3g, %.3g); ', [Rec.Fx, Rec.Fy]);
      end;
    end;
    if Length(s) = 0 then s := 'Clear;';
    CodeString.Text := s;
  end else
  {if Mode = tmProjective then}
  begin
    PT.X0 := Vertices[0].X;
    PT.Y0 := Vertices[0].Y;
    PT.X1 := Vertices[1].X;
    PT.Y1 := Vertices[1].Y;
    PT.X2 := Vertices[2].X;
    PT.Y2 := Vertices[2].Y;
    PT.X3 := Vertices[3].X;
    PT.Y3 := Vertices[3].Y;
  end
end;

procedure TAG32SkewForm.FormDestroy(Sender: TObject);
begin
  AT.Free;
  PT.Free;
end;

procedure TAG32SkewForm.Button1Click(Sender: TObject);
begin
  ClearTransformations;
  ShowSettings(Listbox.ItemIndex);
  DoTransform;
end;

procedure TAG32SkewForm.ListBoxClick(Sender: TObject);
begin
  ShowSettings(ListBox.ItemIndex);
end;

procedure TAG32SkewForm.ShowSettings(OperationNum: Integer);
begin
  LoadingValues := True;
  ListBox.ItemIndex := OperationNum;
  Current := @Operation[OperationNum];
  Combobox.ItemIndex := Ord(Current.OpType);
  NoteBook.PageIndex := Ord(Current.OpType);
  eDx.Text := Format('%.4g', [Current.Dx]);
  eDy.Text := Format('%.4g', [Current.Dy]);
  sbDx.Position := Round(Current.Dx * 10);
  sbDy.Position := Round(Current.Dy * 10);
  eSx.Text := Format('%.4g', [Current.Sx]);
  eSy.Text := Format('%.4g', [Current.Sy]);
  sbSx.Position := Round(Current.Sx * 100);
  sbSy.Position := Round(Current.Sy * 100);
  eCx.Text := Format('%.4g', [Current.Cx]);
  eCy.Text := Format('%.4g', [Current.Cy]);
  eAlpha.Text := Format('%.4g', [Current.Alpha]);
  sbAlpha.Position := Round(Current.Alpha * 2);
  eFx.Text := Format('%.4g', [Current.Fx]);
  eFy.Text := Format('%.4g', [Current.Fy]);
  sbFx.Position := Round(Current.Fx * 100);
  sbFy.Position := Round(Current.Fy * 100);
  LoadingValues := False;
end;

procedure TAG32SkewForm.ComboBoxChange(Sender: TObject);
begin
  Current.OpType := OpTypes[ComboBox.ItemIndex];
  ShowSettings(ListBox.ItemIndex);
  DoTransform;
end;

procedure TAG32SkewForm.TranslationChanged(Sender: TObject);
var
  Tx, Ty: Extended;
begin
  if LoadingValues then Exit;
  if GetVal(eDx.Text, Tx) and GetVal(eDy.Text, Ty) then
  begin
    Current.Dx := Tx;
    Current.Dy := Ty;
    DoTransform;
    LoadingValues := True;
    sbDx.Position := Round(Current.Dx * 10);
    sbDy.Position := Round(Current.Dy * 10);
    LoadingValues := False;
  end;
end;

procedure TAG32SkewForm.TranslationScrolled(Sender: TObject);
begin
  if LoadingValues then Exit;
  Current.Dx := sbDx.Position / 10;
  Current.Dy := sbDy.Position / 10;
  DoTransform;
  LoadingValues := True;
  eDx.Text := FloatToStr(Current.Dx);
  eDy.Text := FloatToStr(Current.Dy);
  LoadingValues := False;
end;

procedure TAG32SkewForm.ScaleChanged(Sender: TObject);
var
  Sx, Sy: Extended;
begin
  if LoadingValues then Exit;
  if GetVal(eSx.Text, Sx) and GetVal(eSy.Text, Sy) then
  begin
    Current.Sx := Sx;
    Current.Sy := Sy;
    DoTransform;
    LoadingValues := True;
    sbSx.Position := Round(Current.Sx * 100);
    sbSy.Position := Round(Current.Sy * 100);
    LoadingValues := False;
  end;
end;

procedure TAG32SkewForm.ScaleScrolled(Sender: TObject);
begin
  if LoadingValues then Exit;
  Current.Sx := sbSx.Position / 100;
  Current.Sy := sbSy.Position / 100;
  DoTransform;
  LoadingValues := True;
  eSx.Text := FloatToStr(Current.Sx);
  eSy.Text := FloatToStr(Current.Sy);
  LoadingValues := False;
end;

procedure TAG32SkewForm.RotationChanged(Sender: TObject);
var
  Cx, Cy, Alpha: Extended;
begin
  if LoadingValues then Exit;
  if GetVal(eCx.Text, Cx) and GetVal(eCy.Text, Cy) and
    GetVal(eAlpha.Text, Alpha) then
  begin
    Current.Cx := Cx;
    Current.Cy := Cy;
    Current.Alpha := Alpha;
    DoTransform;
    LoadingValues := True;
    sbAlpha.Position := Round(Alpha * 2);
    LoadingValues := False;
  end;
end;

procedure TAG32SkewForm.RotationScrolled(Sender: TObject);
begin
  if LoadingValues then Exit;
  Current.Alpha := sbAlpha.Position / 2;
  DoTransform;
  LoadingValues := True;
  eAlpha.Text := FloatToStr(Current.Alpha / 2);
  LoadingValues := False;
end;

procedure TAG32SkewForm.SkewChanged(Sender: TObject);
var
  Fx, Fy: Extended;
begin
  if LoadingValues then Exit;
  if GetVal(eFx.Text, Fx) and GetVal(eFy.Text, Fy) then
  begin
    Current.Fx := Fx;
    Current.Fy := Fy;
    DoTransform;
    LoadingValues := True;
    sbFx.Position := Round(Current.Fx * 10);
    sbFy.Position := Round(Current.Fy * 10);
    LoadingValues := False;
  end;
end;

procedure TAG32SkewForm.SkewScrolled(Sender: TObject);
begin
  if LoadingValues then Exit;
  Current.Fx := sbFx.Position / 10;
  Current.Fy := sbFy.Position / 10;
  DoTransform;
  LoadingValues := True;
  eFx.Text := FloatToStr(Current.Fx);
  eFy.Text := FloatToStr(Current.Fy);
  LoadingValues := False;
end;

procedure TAG32SkewForm.RadioGroup1Click(Sender: TObject);
const
  {STRETCH_FILTER: array [0..1] of TStretchFilter =
  sfNearest, sfLinear, sfLinear2, sfSpline
                            (sfNearest, sfLinear);}
  STRETCH_FILTER: array [0..4] of TStretchFilter =
   {(sfNearest, sfLinear, sfLinear2, sfSpline); 1.5  1.5.1 change to:}
(sfNearest, sfLinear, sfSpline, sfLanczos, sfMitchell);
begin
  Src.Bitmap.StretchFilter :=
                  STRETCH_FILTER[RadioGroup1.ItemIndex];
  DoTransform;
end;

procedure TAG32SkewForm.OpacityChange(Sender: TObject);
begin
  OpacityBar.Update;
  Src.Bitmap.MasterAlpha := OpacityBar.Position;
  DoTransform;
end;

procedure TAG32SkewForm.InitVertices;
begin
  Vertices[0].X := 0;
  Vertices[0].Y := 0;
  Vertices[1].X := Src.Bitmap.Width - 1;
  Vertices[1].Y := 0;
  Vertices[2].X := Src.Bitmap.Width - 1;
  Vertices[2].Y := Src.Bitmap.Height - 1;
  Vertices[3].X := 0;
  Vertices[3].Y := Src.Bitmap.Height - 1;
end;

procedure TAG32SkewForm.PageControl1Change(Sender: TObject);
begin
  if PageControl1.ActivePage = AffineTS then
  begin
    Mode := tmAffine;
    TT := AT;
    RadioGroup1.Parent := AffineTS;
  end
  else if PageControl1.ActivePage = ProjectiveTS then
  begin
    // set current transformation as projective
    Mode := tmProjective;
    TT := PT;
    InitVertices;
    RadioGroup1.Parent := ProjectiveTS;
  end;
  DoTransform;
end;

procedure TAG32SkewForm.RubberLayerMouseDown(Sender: TObject;
  Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
var
  I: Integer;
begin
  if Mode = tmAffine then Exit;

  DraggedVertex := -1;

  // find the vertex to drag
  for I := 0 to 3 do
    if (Abs(Vertices[I].X - X) < 3)
        and (Abs(Vertices[I].Y - Y) < 3) then
    begin
      DraggedVertex := I;
      Break;
    end;

  // or drag all of them, (DragVertex = 4)
  if DraggedVertex = -1 then DraggedVertex := 4;

  // store current mouse position
  LastMousePos := Point(X, Y);
  if Layer = nil then
  begin
    Selection := nil;
    ReleaseCapture;
  end;
end;

procedure TAG32SkewForm.RubberLayerMouseMove(Sender: TObject;
   Shift: TShiftState;
  X, Y: Integer; Layer: TCustomLayer);
var
  Dx, Dy, I: Integer;
begin
  if Mode = tmAffine then Exit;
  
  if DraggedVertex = -1 then Exit; // mouse is not pressed

  Dx := X - LastMousePos.X;
  Dy := Y - LastMousePos.Y;
  LastMousePos := Point(X, Y);

  // update coords
  if DraggedVertex = 4 then
  begin
    for I := 0 to 3 do
    begin
      Inc(Vertices[I].X, Dx);
      Inc(Vertices[I].Y, Dy);
    end;
  end
  else
  begin
    Inc(Vertices[DraggedVertex].X, Dx);
    Inc(Vertices[DraggedVertex].Y, Dy);
  end;

  DoTransform;
end;

procedure TAG32SkewForm.RubberLayerMouseUp(Sender: TObject;
  Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
begin
  DraggedVertex := -1;
end;



procedure TAG32SkewForm.PaintHandles(Sender: TObject; BackBuffer: TBitmap32);
var
  I, X0, Y0, X1, Y1: Integer;

  procedure PaintVertex(X, Y: Integer);
  begin
    BackBuffer.FillRectS(X - 2, Y - 2, X + 2, Y + 2, clWhite32);
    BackBuffer.FrameRectS(X - 3, Y - 3, X + 3, Y + 3, clBlack32);
  end;

begin
  if PageControl1.ActivePage <> ProjectiveTS then Exit;

  BackBuffer.SetStipple([clBlack32, clBlack32, clWhite32, clWhite32]);
  BackBuffer.StippleStep := 0.5;
  BackBuffer.StippleCounter := StippleStart;

  X0 := Vertices[3].X;
  Y0 := Vertices[3].Y;
  for I := 0 to 3 do
  begin
    X1 := Vertices[I].X;
    Y1 := Vertices[I].Y;
    BackBuffer.LineFSP(X0, Y0, X1, Y1);
    X0 := X1;
    Y0 := Y1;
  end;
  for I := 0 to 3 do PaintVertex(Vertices[I].X, Vertices[I].Y);
end;
(*************************************************************)
procedure TAG32SkewForm.AppEventsIdle(Sender: TObject; var Done: Boolean);
begin
  StippleStart := StippleStart - 0.05;
  Dst.Invalidate;
end;
(*************************************************************)
procedure TAG32SkewForm.FormShow(Sender: TObject);
begin
  Application.OnIdle := AppEventsIdle;
end;

procedure TAG32SkewForm.FormHide(Sender: TObject);
begin
  Application.OnIdle := nil;
end;

(*************************************************************)

(*************************************************************)
 procedure TAG32SkewForm.SetSelection(Value: TPositionedLayer);
begin
  if Value <> FSelection then
  begin
    {if RBLayer <> nil then
    begin
      RBLayer.ChildLayer := nil;
      RBLayer.LayerOptions := LOB_NO_UPDATE;
      pnlBitmapLayer.Visible := False;
      pnlMagn.Visible := False;
      ImgView.Invalidate;
    end;}

    FSelection := Value;

    if Value <> nil then
    begin
      {if RBLayer = nil then
      begin
        RBLayer := TRubberBandLayer.Create(ImgView.Layers);
        RBLayer.MinHeight := 1;
        RBLayer.MinWidth := 1;
      end
      else RBLayer.BringToFront;
      RBLayer.ChildLayer := Value;
      RBLayer.LayerOptions := LOB_VISIBLE or LOB_MOUSE_EVENTS or LOB_NO_UPDATE;
      RBLayer.OnResizing := RBResizing;}

      if Value is TBitmapLayer then
        with TBitmapLayer(Value) do
        begin
{          pnlBitmapLayer.Visible := True;}
          LayerOpacity.Position := Bitmap.MasterAlpha;
          LayerInterpolate.Checked := Bitmap.StretchFilter = sfLinear;
        end
      else if Value.Tag = 2 then
      begin
        // tag = 2 for magnifiers
          MagnifierOn:=True;
{        pnlMagn.Visible := True;}
      end;
    end;
  end;
end;






function TAG32SkewForm.CreatePositionedLayer: TPositionedLayer;
var
  P: TPoint;
begin
  // get coordinates of the center of viewport
  with Dst.GetViewportRect do
    P := Dst.ControlToBitmap(Point((Right + Left) div 2, (Top + Bottom) div 2));

  Result := TPositionedLayer.Create(Dst.Layers);
  Result.Location := FloatRect(P.X - 32, P.Y - 32, P.X + 32, P.Y + 32);
  Result.Scaled := True;
  Result.MouseEvents := True;
  Result.OnMouseDown := LayerMouseDown;
end;


procedure TAG32SkewForm.LayerMouseDown(Sender: TObject; Buttons: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Sender <> nil then Selection := TPositionedLayer(Sender);
end;


procedure TAG32SkewForm.LayerOpacityChange(Sender: TObject);
begin
  if Selection is TBitmapLayer then
    TBitmapLayer(Selection).Bitmap.MasterAlpha :=
     LayerOpacity.Position
  else
  begin
  Dst.Bitmap.MasterAlpha :=LayerOpacity.Position;
    {case OpacRG.ItemIndex of
    0:  RotL.Bitmap.MasterAlpha :=LayerOpacity.Position;
    1:  Bml.Bitmap.MasterAlpha :=LayerOpacity.Position;
    2:  ImgView.Bitmap.MasterAlpha :=LayerOpacity.Position;
    end;}
    {  Dst.Invalidate;}
  end;
end;

procedure TAG32SkewForm.mnFlattenClick(Sender: TObject);
var
  B: TBitmap32;
  W, H: Integer;
begin
  { deselect everything }
  Selection := nil;
  W := Dst.Bitmap.Width;
  H := Dst.Bitmap.Height;
  { Create a new bitmap to store a flattened image }
  B := TBitmap32.Create;
  try
    B.SetSize(W, H);
    Dst.PaintTo(B, Rect(0, 0, W, H));

    { destroy all the layers of the original image... }
    Dst.Layers.Clear;
    {RBLayer := nil;} // note that RBLayer reference is destroyed here as well.
                    // The rubber band will be recreated during the next
                    // SetSelection call. Alternatively, you can delete
                    // all the layers except the rubber band.
    { ...and overwrite it with the flattened one }
    Dst.Bitmap := B;
  finally
    B.Free;
  end;
end;

procedure TAG32SkewForm.LayerInterpolateClick(Sender: TObject);
const
  STRETCH_FILTER: array [Boolean] of TStretchFilter =
   (sfNearest, sfLinear);
begin
  if Selection is TBitmapLayer then
  begin
    TBitmapLayer(Selection).Bitmap.StretchFilter := STRETCH_FILTER[LayerInterpolate.Checked];
  end;
end;

procedure TAG32SkewForm.mnBringFrontClick(Sender: TObject);
begin
  // note that the top-most layer is occupied with the rubber-banding layer
  //not here....
  if Selection <> nil then
    case TMenuItem(Sender).Tag of
      1: Selection.BringToFront;
      // Bring to front, do not use BringToFront here, see note above
        {Selection.Index := Dst.Layers.Count - 2;}
      2: Selection.SendToBack;
      3: Selection.Index := Selection.Index + 1; // up one level
      4: Selection.Index := Selection.Index - 1; // down one level
    end;
end;

procedure TAG32SkewForm.mnNewBitmapLayerClick(Sender: TObject);
var
  B: TBitmapLayer;
  P: TPoint;
  W, H: Double;
begin
  with OpenDialog1 do
    if Execute then
    begin
      B := TBitmapLayer.Create(Dst.Layers);
      with B do
      try
        Bitmap.LoadFromFile(FileName);
        Bitmap.DrawMode := dmBlend;

        with Dst.GetViewportRect do
          P := Dst.ControlToBitmap(Point((Right + Left) div 2, (Top + Bottom) div 2));

        W := Bitmap.Width / 2;
        H := Bitmap.Height / 2;

        with Dst.Bitmap do
          Location := FloatRect(P.X - W, P.Y - H, P.X + W, P.Y + H);

        Scaled := True;
        OnMouseDown := LayerMouseDown;
      except
        Free;
        raise;
      end;
      Selection := B;
    end;
end;


procedure TAG32SkewForm.BackgroundCheckerboard1Click(Sender: TObject);
begin
  BackgroundTiledOn:=(not BackgroundTiledOn);
  If BackgroundTiledOn then
  BackgroundCheckerboard1.Checked:=True
  else BackgroundCheckerboard1.Checked:=False;
end;



end.
