unit im_QPCatWinFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, Menus, Printers,
  jpg,jpeg,pngimage,
  GR32_Image, GR32, GR32_Layers,GR32_Polygons, gr32_transforms,
  ExtCtrls, Buttons, StdCtrls;

type
  TBlock = Record
    Group: Integer;
    Color:TColor;
  end;

  TCatWinForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Edit1: TMenuItem;
    Paint1: TMenuItem;
    Help1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Print1: TMenuItem;
    Close1: TMenuItem;
    N1: TMenuItem;
    BackgroundColor1: TMenuItem;
    Column1: TMenuItem;
    Row1: TMenuItem;
    Square1: TMenuItem;
    SaveAs1: TMenuItem;
    MainPanel: TPanel;
    New1: TMenuItem;
    ColorPanel: TPanel;
    ColorDialog1: TColorDialog;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    BackgroundPanel: TPanel;
    GroupListBox: TListBox;
    AddBtn: TSpeedButton;
    DeleteBtn: TSpeedButton;
    AddEdit: TEdit;
    PaintAll: TMenuItem;
    Block1: TMenuItem;
    N2: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    N3: TMenuItem;
    SaveImage1: TMenuItem;
    N4: TMenuItem;
    BlockColor1: TMenuItem;
    Random1: TMenuItem;
    RREdit: TEdit;
    Label3: TLabel;
    ImgView321: TImage32;
    PrinterSetupDialog1: TPrinterSetupDialog;
    CountTotals1: TMenuItem;
    N5: TMenuItem;
    SaveImageResized1: TMenuItem;
    ChangeEdit: TEdit;
    ChangeBtn: TSpeedButton;
    ChangePanel: TPanel;
    VerifyBlock1: TMenuItem;
    Recrunch1: TMenuItem;
    Flake1: TMenuItem;
    Diamond1: TMenuItem;
    N6: TMenuItem;
    PrintImageResized1: TMenuItem;
    DblFillPanel: TPanel;
    DblFillEdit: TEdit;
    Label4: TLabel;
    DblFillEdit2: TEdit;
    TwoToneStar: TMenuItem;
    VerificationEdit: TEdit;
    VerificationPanel: TPanel;
    Label5: TLabel;
    RandomSelected1: TMenuItem;
    BlockDuplicatesPanel: TPanel;
    N7: TMenuItem;
    ShowSquareMaker1: TMenuItem;
    GroupBox1: TGroupBox;
    QBCB1: TCheckBox;
    QBCB2: TCheckBox;
    QBCB3: TCheckBox;
    QBCB4: TCheckBox;
    QBCB5: TCheckBox;
    QBCB6: TCheckBox;
    QBCB7: TCheckBox;
    QBCB8: TCheckBox;
    QBCB9: TCheckBox;
    QBCB10: TCheckBox;
    QBCB11: TCheckBox;
    QBCB12: TCheckBox;
    ImageQB321: TImage32;
    PaintQuiltBlocksBtn: TSpeedButton;
    ClearQBBtn: TSpeedButton;
    GroupBox2: TGroupBox;
    ColorsClearBtn: TSpeedButton;
    ColorsSaveBtn: TSpeedButton;
    ColorsLoadBtn: TSpeedButton;
    RepaintAllasis1: TMenuItem;
    GroupBox3: TGroupBox;
    WithColorsCB: TCheckBox;
    QbSaveBtn: TSpeedButton;
    QBLoadBtn: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Close1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
PROCEDURE PrintBitmap(Canvas:  TCanvas;
              DestRect:  TRect;  Bitmap:  TBitmap);    
    procedure BackgroundColor1Click(Sender: TObject);
    procedure Square1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
procedure CreateBlank;
    procedure ColorPanelClick(Sender: TObject);
    procedure AddBtnClick(Sender: TObject);
    procedure DeleteBtnClick(Sender: TObject);
procedure PaintAllBlocks;
    procedure BackgroundPanelClick(Sender: TObject);
    procedure PaintAllClick(Sender: TObject);
    procedure Block1Click(Sender: TObject);
    procedure Column1Click(Sender: TObject);
    procedure Row1Click(Sender: TObject);
    procedure SaveImage1Click(Sender: TObject);
    procedure BlockColor1Click(Sender: TObject);
    procedure Random1Click(Sender: TObject);
    procedure GroupListBoxClick(Sender: TObject);
    procedure Image321MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure FormResize(Sender: TObject);
    procedure CountTotals1Click(Sender: TObject);
    procedure SaveImageResized1Click(Sender: TObject);
    procedure ChangeBtnClick(Sender: TObject);
    procedure ChangePanelClick(Sender: TObject);
    procedure VerifyBlock1Click(Sender: TObject);
    procedure RepaintAllasis1Click(Sender: TObject);
    procedure Recrunch1Click(Sender: TObject);
    procedure Flake1Click(Sender: TObject);
    procedure Diamond1Click(Sender: TObject);
    procedure PrintImageResized1Click(Sender: TObject);
    procedure GroupListBoxDblClick(Sender: TObject);
    procedure TwoToneStarClick(Sender: TObject);
    procedure RandomSelected1Click(Sender: TObject);

    procedure ShowSquareMaker1Click(Sender: TObject);
    procedure ImageQB321MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure PaintQuiltBlocksBtnClick(Sender: TObject);
    procedure ClearQBBtnClick(Sender: TObject);
procedure PaintAllQBBlocks;
    procedure QbSaveBtnClick(Sender: TObject);
    procedure QBLoadBtnClick(Sender: TObject);


    procedure ColorsSaveBtnClick(Sender: TObject);
    procedure ColorsClearBtnClick(Sender: TObject);
    procedure ColorsLoadBtnClick(Sender: TObject);

  private
    { Private declarations }
    BlockArray: Array [1..19,1..49] of TBlock;
    QBBlockArray: Array [1..7,1..13] of TBlock;
    CatList: TStringList;
    {  Group, X,Y: Integer;  Color:TColor;}
  public
    { Public declarations }
  end;

var
  CatWinForm: TCatWinForm;

implementation

uses im_D5;

{$R *.DFM}

procedure TCatWinForm.FormCreate(Sender: TObject);
var Bitmap:TBitmap;
begin
  top := CatWinFormY;
  left := CatWinFormX;
  Bitmap:=TBitmap.Create;
  Bitmap.Width:=190;   {190}
  Bitmap.Height:=490;  {490}
  ImgView321.Bitmap.assign(Bitmap);
  Bitmap.Free;

  Bitmap:=TBitmap.Create;
  Bitmap.Width:=70;   {70}
  Bitmap.Height:=130;  {130}
  ImageQB321.Bitmap.assign(Bitmap);
  Bitmap.Free;
  CatList:= TStringList.Create;

  CreateBlank;
  Randomize;

  ClearQBBtnClick(Sender);
    MainPanel.Align:=alNone;
    BlockDuplicatesPanel.Align:=alNone;
    BlockDuplicatesPanel.Visible:=False;

end;
procedure TCatWinForm.FormShow(Sender: TObject);
begin
    //showmessage('ok');
    CatWinForm.Width:= (311);  //496-185
   // CatWinForm.Height:= 545;
    //BlockDuplicatesPanel.Align:=alRight;
    MainPanel.Align:=alRight;
end;
procedure TCatWinForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CatWinFormX := CatWinForm.left;
  CatWinFormY := CatWinForm.top;
  CatList.Free;
end;

procedure TCatWinForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
   {If Modified then Save it?}
end;

procedure TCatWinForm.Close1Click(Sender: TObject);
begin
  Close;
end;



procedure TCatWinForm.Open1Click(Sender: TObject);
var
  Layers,X,Y:Integer;
  F: TextFile;
  S: string;
begin
  OpenDialog1.InitialDir :=ImagePath;
  OpenDialog1.Filter :='*.txt';
  {OpenDialog1 path, filename, file types :
   FIRST LINE is the switch to ID as what type Quilt Pattern it is}
  if OpenDialog1.Execute then          { Display Open dialog box }
  begin
    Application.ProcessMessages;
    ImagePath:=ExtractFilePath(OpenDialog1.FileName);
    AssignFile(F, OpenDialog1.FileName);   { File selected in dialog box }
    Reset(F);
    Readln(F, S);    { Read the first line out of the file to determine type}
    if (S='Cathedral Window') then {Set a Switch}
    begin end else
    begin
      Showmessage('Mot a Cathedral Window file');
      CloseFile(F);
      Exit;{dont do any more}
    end;
    Readln(F, S);
    AddEdit.Text := S;     { Put string in a TEdit control }
    Readln(F, S);
    BackgroundPanel.Color:=strtoint(s);
    Readln(F, S);
    Layers:=Strtoint(S);
    {BlockArray: Array [1..19,1..49] of TBlock;}
    GroupListBox.Clear;
    CatList.Clear;
    For x:=0 to Layers-1 do
    begin
      Readln(F, S);
      GroupListBox.Items.Add(S);
      Readln(F, S);
      CatList.Add(S);
    end;
    GroupListBox.ItemIndex:=0;
    ColorPanel.Color:=strtoint(CatList[0]);

    For X:=1 to 19 do    {36}
    For Y:= 1 to 49 do    {48}
    Begin
      Readln(F, S);
      BlockArray[X,Y].Group:=strtoint(S);
      Readln(F, S);
      BlockArray[X,Y].Color:=strtoint(S);
    End;
    CloseFile(F);
    Save1.Enabled:=True;
    SaveDialog1.FileName:=OpenDialog1.FileName;
    PaintAllBlocks;
  end;
end;

procedure TCatWinForm.CountTotals1Click(Sender: TObject);
var
  F: TextFile;
  TotalHalvies   ,TotalLayerCount ,
  Halvies,  Layers,LayerCount,X,Y,z:Integer;
  S: string;
begin
  SaveDialog1.InitialDir :=ImagePath;
  SaveDialog1.Filter :='*.txt';
  if SaveDialog1.Execute then
  Begin
    GroupListBox.ItemIndex:=0;
    Application.ProcessMessages;
    AssignFile(F, ChangeFileExt(SaveDialog1.Filename,'.txt'));
    Rewrite(F);
    S:='Cathedral Window Block Color Count';
    Writeln(F, S);  Writeln(F, '');
    Layers:=GroupListBox.Items.Count;
    TotalHalvies:=0;
    TotalLayerCount:=0;
    For z:=0 to Layers-1 do
    begin
      s:=(GroupListBox.Items[z]);
      Writeln(F, 'Layer: '+Inttostr(z)+' Color: '+S);
      s:=(CatList[z]);
      Writeln(F, 'Color: '+S);
      LayerCount:=0;
      Halvies:=0;
      For X:=1 to 19 do
        For Y:= 1 to 49 do
        If BlockArray[X,Y].Group=z then
        begin
          If ((Y=1) or (Y=49)) then
          begin
            If (X=19) then begin {skip it} end else
            begin
              inc(Halvies);
              inc(TotalHalvies);
            end
          end else
          if ((y mod 2) =0) then   {Even rows}
          begin
              If ((x=1) or (X=19)) then begin inc(Halvies); inc(TotalHalvies); end
              else begin inc(LayerCount); inc(TotalLayerCount); end;
          end  else
          begin  {odd rows}
            If (X=19) then begin {skip it} end
            else begin inc(LayerCount); inc(TotalLayerCount); end;
          end;
        end;
      Writeln(F, 'Blocks: '+Inttostr(LayerCount));
      Writeln(F, 'Half Blocks: '+Inttostr(Halvies));
      Writeln(F, '');
    end;
      Writeln(F, 'Total Blocks: '+Inttostr(TotalLayerCount));
      Writeln(F, 'Total Half Blocks: '+Inttostr(TotalHalvies));
      Writeln(F, '');
    CloseFile(F);
  end;
end;

(*
  For X:=0 to 18 do    {19}
    For Y:= 0 to 48 do  {49}
  begin
    TempBitmap.Canvas.Brush.Color := BlockArray[X+1,Y+1].Color;
    if ((y mod 2) =0) then
    TempBitmap.Canvas.Ellipse(
     (X*10)+1,
     (Y*10)+1,
     ((X+1)*10)-1,
     ((Y+1)*10)-1) else
    TempBitmap.Canvas.Ellipse(
     (X*10)-3,
     (Y*10)+1,
     ((X+1)*10)-5,
     ((Y+1)*10)-1);
  end;
*)
(*  If Column1.Checked then
  begin
    {For X:=0 to 34 do Row1}
    For Yb:= 1 to 49 do
    begin
      if ((x mod 10) =0) then
      begin
        if ((yb mod 2) =0) then
        begin
          BlockArray[(X div 10)+1,Yb].Color:=ColorPanel.Color;
          BlockArray[(X div 10)+1,Yb].Group:=GroupListBox.ItemIndex;
        end;
      end else
      begin
        if ((yb mod 2) <>0) then
        begin
          BlockArray[(X div 10)+1,Yb].Color:=ColorPanel.Color;
           BlockArray[(X div 10)+1,Yb].Group:=GroupListBox.ItemIndex;
        end;
      end;
    end;
  end else*)

procedure TCatWinForm.Save1Click(Sender: TObject);
var
  Layers,X,Y:Integer;
  F: TextFile;
  S: string;
begin
  GroupListBox.ItemIndex:=0;
  Application.ProcessMessages;
  AssignFile(F, ChangeFileExt(SaveDialog1.Filename,'.txt'));
  Rewrite(F);
  S:='Cathedral Window';
  Writeln(F, S);
  S:=AddEdit.Text;
  Writeln(F, S);
    s:=inttostr(BackgroundPanel.Color);
    Writeln(F, S);
    Layers:=GroupListBox.Items.Count;
    s:=inttostr(Layers);
    Writeln(F, S);

    For x:=0 to Layers-1 do
    begin
      s:=(GroupListBox.Items[x]);
      Writeln(F, S);
      s:=(CatList[x]);
      Writeln(F, S);
    end;

    For X:=1 to 19 do
    For Y:= 1 to 49 do
    Begin
      s:=inttostr(BlockArray[X,Y].Group);
      Writeln(F, S);
      s:=inttostr(BlockArray[X,Y].Color);
      Writeln(F, S);
    End;
  CloseFile(F);
end;

procedure TCatWinForm.SaveAs1Click(Sender: TObject);
begin
  SaveDialog1.InitialDir :=ImagePath;
  SaveDialog1.Filter :='*.txt';
  if SaveDialog1.Execute then Save1Click(Sender);
end;

procedure TCatWinForm.Print1Click(Sender: TObject);
var
  PrintRect: TRect;
  TempBitmap:TBitmap;
begin
  if PrinterSetupDialog1.Execute {PrintDialog1.Execute} then
  begin
    Application.ProcessMessages;
    { Add code to print current file }
    with Printer do
    begin
      BeginDoc;
      TempBitmap := TBitmap.Create;
      TempBitmap.Assign(ImgView321.Bitmap);
      {Image1.Picture.Bitmap or FBitmap
      Check to see if enlarged print is available}
{      if PrintBigChecked then
      begin}
      If((PageWidth > (ImgView321.Bitmap.Width * 4)) and
        (PageHeight > (ImgView321.Bitmap.Height * 4))) then
        begin
        {Rect(0, 0, Image.Width, Image.Height);}
        PrintRect := Rect(
          (PageWidth - (ImgView321.Bitmap.Width * 4)) div 2,
          (PageHeight - (ImgView321.Bitmap.Height * 4)) div 2,
          (((PageWidth - (ImgView321.Bitmap.Width * 4)) div 2)
          + (ImgView321.Bitmap.Width * 4)),
          (((PageHeight - (ImgView321.Bitmap.Height * 4)) div 2)
          + (ImgView321.Bitmap.Height * 4)));
        PrintBitmap(Printer.Canvas, PrintRect, TempBitmap);
{        Canvas.StretchDraw(PrintRect, Image1.Picture.Bitmap);}
        end else
      If((PageWidth > (ImgView321.Bitmap.Width * 2)) and
        (PageHeight > (ImgView321.Bitmap.Height * 2))) then
        begin
        {Rect(0, 0, Image.Width, Image.Height);}
        PrintRect := Rect(
          (PageWidth - (ImgView321.Bitmap.Width * 2)) div 2,
          (PageHeight - (ImgView321.Bitmap.Height * 2)) div 2,
          (((PageWidth - (ImgView321.Bitmap.Width * 2)) div 2)
          + (ImgView321.Bitmap.Width * 2)),
          (((PageHeight - (ImgView321.Bitmap.Height * 2)) div 2)
          + (ImgView321.Bitmap.Height * 2)));
        PrintBitmap(Printer.Canvas, PrintRect, TempBitmap);
        {Canvas.StretchDraw(PrintRect, Image1.Picture.Bitmap);}
        end;
      EndDoc;
      TempBitmap.Free;
    end;
  end;
end;

procedure TCatWinForm.PrintImageResized1Click(Sender: TObject);
Var
  RectS: TRect;
  RectD: TRect;
  FSrcBitmap:TBitmap32;
  FDestBitmap:TBitmap32;
var
  PrintRect: TRect;
  TempBitmap:TBitmap;
begin
    RectS.Top := 0;
    RectS.Left := 0;
    RectS.Right := 183;{180 too small? delete out the right edge 190}
    RectS.Bottom := 490;
    RectD.Top := 0;
    RectD.Left := 0;
    RectD.Right := 183;
    RectD.Bottom := 240;

    FDestBitmap:=TBitmap32.Create;
    FDestBitmap.Clear(clGray32);
    FDestBitmap.Width:=183;
    FDestBitmap.Height:=240;
    FSrcBitmap:=TBitmap32.Create;
    FSrcBitmap.Assign(ImgView321.Bitmap);
    {(sfNearest, sfLinear, sfSpline, sfLanczos, sfMitchell)}
    StretchTransfer(FDestBitmap,RectD,RectD,
                FSrcBitmap, RectS,sfMitchell, dmBlend, Nil);
  if PrinterSetupDialog1.Execute {PrintDialog1.Execute} then
  begin
    Application.ProcessMessages;
    { Add code to print current file }
    with Printer do
    begin
      BeginDoc;
      TempBitmap := TBitmap.Create;
      TempBitmap.Assign(FDestBitmap);
      {Image1.Picture.Bitmap or FBitmap
      Check to see if enlarged print is available}
{      if PrintBigChecked then
      begin}
      If((PageWidth > (FDestBitmap.Width * 4)) and
        (PageHeight > (FDestBitmap.Height * 4))) then
        begin
        {Rect(0, 0, Image.Width, Image.Height);}
        PrintRect := Rect(
          (PageWidth - (FDestBitmap.Width * 4)) div 2,
          (PageHeight - (FDestBitmap.Height * 4)) div 2,
          (((PageWidth - (FDestBitmap.Width * 4)) div 2)
          + (FDestBitmap.Width * 4)),
          (((PageHeight - (FDestBitmap.Height * 4)) div 2)
          + (FDestBitmap.Height * 4)));
        PrintBitmap(Printer.Canvas, PrintRect, TempBitmap);
{        Canvas.StretchDraw(PrintRect, Image1.Picture.Bitmap);}
        end else
      If((PageWidth > (FDestBitmap.Width * 2)) and
        (PageHeight > (FDestBitmap.Height * 2))) then
        begin
        {Rect(0, 0, Image.Width, Image.Height);}
        PrintRect := Rect(
          (PageWidth - (FDestBitmap.Width * 2)) div 2,
          (PageHeight - (FDestBitmap.Height * 2)) div 2,
          (((PageWidth - (FDestBitmap.Width * 2)) div 2)
          + (FDestBitmap.Width * 2)),
          (((PageHeight - (FDestBitmap.Height * 2)) div 2)
          + (FDestBitmap.Height * 2)));
        PrintBitmap(Printer.Canvas, PrintRect, TempBitmap);
        {Canvas.StretchDraw(PrintRect, Image1.Picture.Bitmap);}
        end;
      EndDoc;
      TempBitmap.Free;
    end;
  end;
    FDestBitmap.Free;
    FSrcBitmap.Free;
end;

  // Based on posting to borland.public.delphi.winapi by Rodney E Geraghty,
  // 8/8/97.  Used to print bitmap on any Windows printer.
PROCEDURE TCatWinForm.PrintBitmap(Canvas:  TCanvas;
              DestRect:  TRect;  Bitmap:  TBitmap);
    VAR
      BitmapHeader:  pBitmapInfo;
      BitmapImage :  POINTER;
      HeaderSize  :  DWORD;
      ImageSize   :  DWORD;
  BEGIN
    GetDIBSizes(Bitmap.Handle, HeaderSize, ImageSize);
    GetMem(BitmapHeader, HeaderSize);
    GetMem(BitmapImage,  ImageSize);
    TRY
      GetDIB(Bitmap.Handle, Bitmap.Palette, BitmapHeader^, BitmapImage^);
      StretchDIBits(Canvas.Handle,
                    DestRect.Left, DestRect.Top,     // Destination Origin
                    DestRect.Right  - DestRect.Left, // Destination Width
                    DestRect.Bottom - DestRect.Top,  // Destination Height
                    0, 0,                            // Source Origin
                    Bitmap.Width, Bitmap.Height,     // Source Width & Height
                    BitmapImage,
                    TBitmapInfo(BitmapHeader^),
                    DIB_RGB_COLORS,
                    SRCCOPY)
    FINALLY
      FreeMem(BitmapHeader);
      FreeMem(BitmapImage)
    END
END {PrintBitmap};


procedure TCatWinForm.SaveImage1Click(Sender: TObject);
begin
  SaveDialog1.InitialDir :=ImagePath;
    SaveDialog1.Filter :='*.bmp';
  if SaveDialog1.Execute then
    ImgView321.Bitmap.Savetofile(ChangeFileExt(SaveDialog1.Filename,'.bmp'));
end;

procedure TCatWinForm.SaveImageResized1Click(Sender: TObject);
Var
  RectS: TRect;
  RectD: TRect;
  FSrcBitmap:TBitmap32;
  FDestBitmap:TBitmap32;
begin
  SaveDialog1.InitialDir :=ImagePath;
    SaveDialog1.Filter :='*.bmp';
  if SaveDialog1.Execute then
  begin
    RectS.Top := 0;
    RectS.Left := 0;
    RectS.Right := 183;{180 too small? delete out the right edge 190}
    RectS.Bottom := 490;
    RectD.Top := 0;
    RectD.Left := 0;
    RectD.Right := 183;
    RectD.Bottom := 240;

    FDestBitmap:=TBitmap32.Create;
    FDestBitmap.Clear(clGray32);
    FDestBitmap.Width:=183;
    FDestBitmap.Height:=240;
    FSrcBitmap:=TBitmap32.Create;
    FSrcBitmap.Assign(ImgView321.Bitmap);
    {(sfNearest, sfLinear, sfSpline, sfLanczos, sfMitchell)}
    StretchTransfer(FDestBitmap,RectD,RectD,
                FSrcBitmap, RectS,sfMitchell, dmBlend, Nil);
    FDestBitmap.Savetofile(ChangeFileExt(SaveDialog1.Filename,'.bmp'));
    FDestBitmap.Free;
    FSrcBitmap.Free;
  end;
end;

procedure TCatWinForm.BackgroundColor1Click(Sender: TObject);
begin
  BackgroundPanelClick(Sender);
end;
procedure TCatWinForm.BlockColor1Click(Sender: TObject);
begin
  ColorPanelClick(Sender);
end;



procedure TCatWinForm.Help1Click(Sender: TObject);
begin
  Application.HelpContext(13000);
end;

procedure TCatWinForm.New1Click(Sender: TObject);
begin
  {Create a Blank Bitmap with All the Patterns Blocks}
  CreateBlank;
end;

procedure TCatWinForm.CreateBlank;
var X,Y:Integer;
begin
  {Create a Blank Bitmap with All the Patterns Blocks}
    {BlockArray: Array [1..19,1..49] of TBlock;}
  GroupListBox.Clear;
  CatList.Clear;
  AddEdit.Text:='Silver';
  GroupListBox.Items.Add(AddEdit.Text);
  CatList.Add(Inttostr(clSilver));
  GroupListBox.ItemIndex:=0;
  ColorPanel.Color:=clSilver;
  For X:=1 to 19 do
  For Y:= 1 to 49 do
  Begin
    BlockArray[X,Y].Group:=0;
    BlockArray[X,Y].Color:=ColorPanel.Color;
  End;
  PaintAllBlocks;
end;


procedure TCatWinForm.ColorPanelClick(Sender: TObject);
begin
  ColorDialog1.Color:= ColorPanel.Color;
  if ColorDialog1.Execute then
  begin
    ColorPanel.Color := ColorDialog1.Color;
  end;
end;
procedure TCatWinForm.BackgroundPanelClick(Sender: TObject);
begin
  ColorDialog1.Color:= BackgroundPanel.Color;
  if ColorDialog1.Execute then
  BackgroundPanel.Color := ColorDialog1.Color;
  PaintAllBlocks;
end;

procedure TCatWinForm.AddBtnClick(Sender: TObject);
begin
  GroupListBox.Items.Add(AddEdit.Text);
  CatList.Add(inttostr(ColorPanel.Color));
end;

procedure TCatWinForm.DeleteBtnClick(Sender: TObject);
var  x,y,i,keeper: Integer;
begin
  If GroupListBox.Items.Count > 1 then
  begin
  keeper:=0;
  for i := 0 to (GroupListBox.Items.Count - 1) do
  begin
  try
    if GroupListBox.Selected[i] then
    begin
      keeper:=i;
      CatList.Delete(i);
      GroupListBox.Items.Delete(i);
      break;
    end;
   finally
   { do something here }
   end;
  end;
  {Repaint All Blocks...
  All Blocks with THAT Group are now WHERE? }
  For X:=1 to 19 do
    For Y:= 1 to 49 do
    If keeper = BlockArray[X,Y].Group then
    Begin
      BlockArray[X,Y].Group:=0;
      BlockArray[X,Y].Color:=strtoint(CatList[0]);
    End;
  PaintAllBlocks;
  end;
  ColorPanel.Color:=  strtoint(CatList[0]);
  AddEdit.Text:=    GroupListBox.Items[0];
  GroupListBox.ItemIndex:=0;
end;


procedure TCatWinForm.PaintAllBlocks;
var
  x,y:Integer;
  TempBitmap:TBitmap;
begin
  TempBitmap := TBitMap.Create;
  TempBitmap.Width:=ImgView321.Width;
  TempBitmap.Height:=ImgView321.Height;
  TempBitmap.Canvas.Brush.Style := bsSolid;
  TempBitmap.Canvas.Pen.Width:=1;
  ImgView321.Color :=BackgroundPanel.Color;
  For X:=0 to 18 do    {19}
  For Y:= 0 to 48 do  {49}
  begin
    TempBitmap.Canvas.Brush.Color := BlockArray[X+1,Y+1].Color;
    if ((y mod 2) =0) then
    TempBitmap.Canvas.Ellipse(
     (X*10)+1,
     (Y*10)+1,
     ((X+1)*10)-1,
     ((Y+1)*10)-1) else
    TempBitmap.Canvas.Ellipse(
     (X*10)-3,
     (Y*10)+1,
     ((X+1)*10)-5,
     ((Y+1)*10)-1);
  end;
    TempBitmap.Canvas.Pen.Width:=8;
    TempBitmap.Canvas.Pen.Color :=BackgroundPanel.Color;
    TempBitmap.Canvas.Moveto(0,0);
    TempBitmap.Canvas.Lineto(185,0);
    TempBitmap.Canvas.Moveto(185,0);
    TempBitmap.Canvas.Lineto(185,489);
    TempBitmap.Canvas.Moveto(185,489);
    TempBitmap.Canvas.Lineto(0,489);
    TempBitmap.Canvas.Pen.Width:=2;
    TempBitmap.Canvas.Moveto(0,489);
    TempBitmap.Canvas.Lineto(0,0);
    ImgView321.Bitmap.Assign(TempBitmap);
    TempBitmap.Free;
end;

procedure TCatWinForm.Image321MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer;
  Layer: TCustomLayer);
var xb,yb:Integer;
begin
  If VerifyBlock1.Checked then
  begin
    VerificationEdit.Text:=
     GroupListBox.Items[BlockArray[(X div 10)+1,(Y div 10)+1].Group];
    {Inttostr(BlockArray[(X div 10)+1,(Y div 10)+1].Group);}
    VerificationPanel.Color:=BlockArray[(X div 10)+1,(Y div 10)+1].Color;
  end else
  If Block1.Checked then
  begin
    BlockArray[(X div 10)+1,(Y div 10)+1].Color:=ColorPanel.Color;
    BlockArray[(X div 10)+1,(Y div 10)+1].Group:=GroupListBox.ItemIndex;
  end else
  If Column1.Checked then
  begin
    For Yb:= 1 to 49 do
    begin
      if ((x mod 10) =0) then
      begin
        if ((yb mod 2) =0) then
        begin
          BlockArray[(X div 10)+1,Yb].Color:=ColorPanel.Color;
          BlockArray[(X div 10)+1,Yb].Group:=GroupListBox.ItemIndex;
        end;
      end else
      begin
        if ((yb mod 2) <>0) then
        begin
          BlockArray[(X div 10)+1,Yb].Color:=ColorPanel.Color;
           BlockArray[(X div 10)+1,Yb].Group:=GroupListBox.ItemIndex;
        end;
      end;
    end;
  end else
  If Row1.Checked then
  begin
    For Xb:=1 to 19 do
    begin
      BlockArray[(Xb),(Y div 10)+1].Color:=ColorPanel.Color;
      BlockArray[(Xb),(Y div 10)+1].Group:=GroupListBox.ItemIndex;
    end;
  end else
  If Flake1.Checked then
  begin
    if (((Y div 10) mod 2) =0) then
    begin
      BlockArray[(X div 10)-1,(Y div 10)+1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)-1,(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10),(Y div 10)+1].Color:=ColorPanel.Color;
      BlockArray[(X div 10),(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+1,(Y div 10)+1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+2,(Y div 10)+1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+3,(Y div 10)+1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+3,(Y div 10)+1].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10)+2,(Y div 10)+2].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)+2].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+2,(Y div 10)+3].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)+3].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+2,(Y div 10)].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+2,(Y div 10)-1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)-1].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10)+1,(Y div 10)+2].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)+2].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10),(Y div 10)+3].Color:=ColorPanel.Color;
      BlockArray[(X div 10),(Y div 10)+3].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+1,(Y div 10)].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10),(Y div 10)-1].Color:=ColorPanel.Color;
      BlockArray[(X div 10),(Y div 10)-1].Group:=GroupListBox.ItemIndex;
    end else
    begin
      BlockArray[(X div 10)-1,(Y div 10)+1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)-1,(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10),(Y div 10)+1].Color:=ColorPanel.Color;
      BlockArray[(X div 10),(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+1,(Y div 10)+1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+2,(Y div 10)+1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+3,(Y div 10)+1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+3,(Y div 10)+1].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10)+1,(Y div 10)+2].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)+2].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+2,(Y div 10)+3].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)+3].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+1,(Y div 10)].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+2,(Y div 10)-1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)-1].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10),(Y div 10)+2].Color:=ColorPanel.Color;
      BlockArray[(X div 10),(Y div 10)+2].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10),(Y div 10)+3].Color:=ColorPanel.Color;
      BlockArray[(X div 10),(Y div 10)+3].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10),(Y div 10)].Color:=ColorPanel.Color;
      BlockArray[(X div 10),(Y div 10)].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10),(Y div 10)-1].Color:=ColorPanel.Color;
      BlockArray[(X div 10),(Y div 10)-1].Group:=GroupListBox.ItemIndex;
    end
  end else
  If Diamond1.Checked then
  begin
    if (((Y div 10) mod 2) =0) then
    begin
      BlockArray[(X div 10),(Y div 10)+1].Color:=ColorPanel.Color;
      BlockArray[(X div 10),(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+2,(Y div 10)+1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+1,(Y div 10)+1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)+1].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10)+1,(Y div 10)].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+2,(Y div 10)].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10)+1,(Y div 10)+2].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)+2].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+2,(Y div 10)+2].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)+2].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10)+1,(Y div 10)-1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)-1].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+1,(Y div 10)+3].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)+3].Group:=GroupListBox.ItemIndex;
    end else
    begin
      BlockArray[(X div 10),(Y div 10)+1].Color:=ColorPanel.Color;
      BlockArray[(X div 10),(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+2,(Y div 10)+1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+1,(Y div 10)+1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)+1].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10),(Y div 10)].Color:=ColorPanel.Color;
      BlockArray[(X div 10),(Y div 10)].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+1,(Y div 10)].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10)+1,(Y div 10)+2].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)+2].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10),(Y div 10)+2].Color:=ColorPanel.Color;
      BlockArray[(X div 10),(Y div 10)+2].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10)+1,(Y div 10)-1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)-1].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+1,(Y div 10)+3].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)+3].Group:=GroupListBox.ItemIndex;
    end;
  end else
  If TwoToneStar.Checked then
  begin
  {          DblFillPanel.Color:=  strtoint(CatList[i]);
          DblFillEdit.Text:=    GroupListBox.Items[i];
          DblFillEdit2.Text:=    inttostr(i);  }
    if (((Y div 10) mod 2) =0) then
    begin
      BlockArray[(X div 10),(Y div 10)+1].Color:=DblFillPanel.Color;
      BlockArray[(X div 10),(Y div 10)+1].Group:=strtoint(DblFillEdit2.Text);
      BlockArray[(X div 10)+2,(Y div 10)+1].Color:=DblFillPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)+1].Group:=strtoint(DblFillEdit2.Text);
      BlockArray[(X div 10)+1,(Y div 10)+1].Color:=DblFillPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)+1].Group:=strtoint(DblFillEdit2.Text);

      BlockArray[(X div 10)+1,(Y div 10)].Color:=DblFillPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)].Group:=strtoint(DblFillEdit2.Text);
      BlockArray[(X div 10)+2,(Y div 10)].Color:=DblFillPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)].Group:=strtoint(DblFillEdit2.Text);

      BlockArray[(X div 10)+1,(Y div 10)+2].Color:=DblFillPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)+2].Group:=strtoint(DblFillEdit2.Text);
      BlockArray[(X div 10)+2,(Y div 10)+2].Color:=DblFillPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)+2].Group:=strtoint(DblFillEdit2.Text);

      BlockArray[(X div 10)+1,(Y div 10)-1].Color:=DblFillPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)-1].Group:=strtoint(DblFillEdit2.Text);
      BlockArray[(X div 10)+1,(Y div 10)+3].Color:=DblFillPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)+3].Group:=strtoint(DblFillEdit2.Text);

       {The Border  REMEMBER the Y is + = DOWN}
      BlockArray[(X div 10)+3,(Y div 10)].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+3,(Y div 10)].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10),(Y div 10)].Color:=ColorPanel.Color;
      BlockArray[(X div 10),(Y div 10)].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10)+2,(Y div 10)-1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)-1].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+3,(Y div 10)-1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+3,(Y div 10)-1].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10),(Y div 10)-1].Color:=ColorPanel.Color;
      BlockArray[(X div 10),(Y div 10)-1].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)-1,(Y div 10)-1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)-1,(Y div 10)-1].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10)+2,(Y div 10)-2].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)-2].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+1,(Y div 10)-2].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)-2].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10)+1,(Y div 10)-3].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)-3].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10),(Y div 10)+2].Color:=ColorPanel.Color;
      BlockArray[(X div 10),(Y div 10)+2].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+3,(Y div 10)+2].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+3,(Y div 10)+2].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10),(Y div 10)+3].Color:=ColorPanel.Color;
      BlockArray[(X div 10),(Y div 10)+3].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)-1,(Y div 10)+3].Color:=ColorPanel.Color;
      BlockArray[(X div 10)-1,(Y div 10)+3].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+2,(Y div 10)+3].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)+3].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+3,(Y div 10)+3].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+3,(Y div 10)+3].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10)+2,(Y div 10)+4].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)+4].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+1,(Y div 10)+4].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)+4].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10)+1,(Y div 10)+5].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)+5].Group:=GroupListBox.ItemIndex;
    end else
    begin
      BlockArray[(X div 10),(Y div 10)+1].Color:=DblFillPanel.Color;
      BlockArray[(X div 10),(Y div 10)+1].Group:=strtoint(DblFillEdit2.Text);
      BlockArray[(X div 10)+2,(Y div 10)+1].Color:=DblFillPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)+1].Group:=strtoint(DblFillEdit2.Text);
      BlockArray[(X div 10)+1,(Y div 10)+1].Color:=DblFillPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)+1].Group:=strtoint(DblFillEdit2.Text);

      BlockArray[(X div 10),(Y div 10)].Color:=DblFillPanel.Color;
      BlockArray[(X div 10),(Y div 10)].Group:=strtoint(DblFillEdit2.Text);
      BlockArray[(X div 10)+1,(Y div 10)].Color:=DblFillPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)].Group:=strtoint(DblFillEdit2.Text);

      BlockArray[(X div 10)+1,(Y div 10)+2].Color:=DblFillPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)+2].Group:=strtoint(DblFillEdit2.Text);
      BlockArray[(X div 10),(Y div 10)+2].Color:=DblFillPanel.Color;
      BlockArray[(X div 10),(Y div 10)+2].Group:=strtoint(DblFillEdit2.Text);

      BlockArray[(X div 10)+1,(Y div 10)-1].Color:=DblFillPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)-1].Group:=strtoint(DblFillEdit2.Text);
      BlockArray[(X div 10)+1,(Y div 10)+3].Color:=DblFillPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)+3].Group:=strtoint(DblFillEdit2.Text);
       {The Border  REMEMBER the Y is + = DOWN}
      BlockArray[(X div 10)-1,(Y div 10)].Color:=ColorPanel.Color;
      BlockArray[(X div 10)-1,(Y div 10)].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+2,(Y div 10)].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10)+2,(Y div 10)-1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)-1].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+3,(Y div 10)-1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+3,(Y div 10)-1].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10),(Y div 10)-1].Color:=ColorPanel.Color;
      BlockArray[(X div 10),(Y div 10)-1].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)-1,(Y div 10)-1].Color:=ColorPanel.Color;
      BlockArray[(X div 10)-1,(Y div 10)-1].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10),(Y div 10)-2].Color:=ColorPanel.Color;
      BlockArray[(X div 10),(Y div 10)-2].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+1,(Y div 10)-2].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)-2].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10)+1,(Y div 10)-3].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)-3].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10)-1,(Y div 10)+2].Color:=ColorPanel.Color;
      BlockArray[(X div 10)-1,(Y div 10)+2].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+2,(Y div 10)+2].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)+2].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10),(Y div 10)+3].Color:=ColorPanel.Color;
      BlockArray[(X div 10),(Y div 10)+3].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)-1,(Y div 10)+3].Color:=ColorPanel.Color;
      BlockArray[(X div 10)-1,(Y div 10)+3].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+2,(Y div 10)+3].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+2,(Y div 10)+3].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+3,(Y div 10)+3].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+3,(Y div 10)+3].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10),(Y div 10)+4].Color:=ColorPanel.Color;
      BlockArray[(X div 10),(Y div 10)+4].Group:=GroupListBox.ItemIndex;
      BlockArray[(X div 10)+1,(Y div 10)+4].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)+4].Group:=GroupListBox.ItemIndex;

      BlockArray[(X div 10)+1,(Y div 10)+5].Color:=ColorPanel.Color;
      BlockArray[(X div 10)+1,(Y div 10)+5].Group:=GroupListBox.ItemIndex;
    end;
  end;
  PaintAllBlocks;
end;



procedure TCatWinForm.PaintAllClick(Sender: TObject);
var x,y:integer;
begin
    For X:=1 to 19 do
    For Y:= 1 to 49 do
    Begin
    BlockArray[X,Y].Group:=GroupListBox.ItemIndex;
    BlockArray[X,Y].Color:=ColorPanel.Color;
    End;
  PaintAllBlocks;
end;

procedure TCatWinForm.Block1Click(Sender: TObject);
begin
  Block1.Checked:=True;
end;
procedure TCatWinForm.Column1Click(Sender: TObject);
begin
  Column1.Checked:=True;
end;
procedure TCatWinForm.Row1Click(Sender: TObject);
begin
  Row1.Checked:=True;
end;
procedure TCatWinForm.Flake1Click(Sender: TObject);
begin
  Flake1.Checked:=True;
end;
procedure TCatWinForm.Diamond1Click(Sender: TObject);
begin
  Diamond1.Checked:=True;
end;
procedure TCatWinForm.TwoToneStarClick(Sender: TObject);
begin
  TwoToneStar.Checked:=True;
end;

procedure TCatWinForm.VerifyBlock1Click(Sender: TObject);
begin
  VerifyBlock1.Checked:=True;
end;
procedure TCatWinForm.RepaintAllasis1Click(Sender: TObject);
begin
  PaintAllBlocks;
end;

procedure TCatWinForm.Random1Click(Sender: TObject);
var RR,Placemat,x,y:integer;
begin
  RR:=Strtoint(RREdit.Text);
  GroupListBox.Clear;
  CatList.Clear;
  for x:= 0 to RR do
  begin
    GroupListBox.Items.Add('Random'+inttostr(x));
    CatList.Add(inttostr(Random(16777216)));
  end;
  For X:=1 to 19 do
    For Y:= 1 to 49 do
    Begin
      Placemat:=Random(RR);{0..6}
      BlockArray[X,Y].Group:=Placemat+1;
      BlockArray[X,Y].Color:=strtoint(CatList[Placemat+1]);
    End;
  GroupListBox.ItemIndex:=0;
  PaintAllBlocks;
end;

procedure TCatWinForm.RandomSelected1Click(Sender: TObject);
var RR,Placemat,x,y:integer;
begin
  RR:=GroupListBox.Items.Count;
  For X:=1 to 19 do
    For Y:= 1 to 49 do
    Begin
      Placemat:=Random(RR);{0..6 of 7}
      BlockArray[X,Y].Group:=Placemat;
      BlockArray[X,Y].Color:=strtoint(CatList[Placemat]);
    End;
  GroupListBox.ItemIndex:=0;
  PaintAllBlocks;
end;


procedure TCatWinForm.GroupListBoxClick(Sender: TObject);
var i:Integer;
begin
  If GroupListBox.Items.Count > 1 then
  begin
    for i := 0 to (GroupListBox.Items.Count - 1) do
    begin
      try
        if GroupListBox.Selected[i] then
        begin
          ColorPanel.Color:=  strtoint(CatList[i]);
          AddEdit.Text:=    GroupListBox.Items[i];
        end;
      finally
      end;
    end;
  end;
end;
procedure TCatWinForm.GroupListBoxDblClick(Sender: TObject);
var i:Integer;
begin
  If GroupListBox.Items.Count > 1 then
  begin
    for i := 0 to (GroupListBox.Items.Count - 1) do
    begin
      try
        if GroupListBox.Selected[i] then
        begin
          DblFillPanel.Color:=  strtoint(CatList[i]);
          DblFillEdit.Text:=    GroupListBox.Items[i];
          DblFillEdit2.Text:=    inttostr(i);
        end;
      finally
      end;
    end;
  end;
end;


procedure TCatWinForm.Square1Click(Sender: TObject);
var xa,z, x,y:integer;
begin  {Duplicate the top Left corner into the others}
  begin
  xa:=6;
  z:=12;
  For Y:= 0 to 3 do
  For X:= 0 to 2 do
    begin
    BlockArray[1+(X*xa),1+(Y*z)].Group:=BlockArray[1,1].Group;
    BlockArray[1+(X*xa),1+(Y*z)].Color:=BlockArray[1,1].Color;
    BlockArray[1+(X*xa),2+(Y*z)].Group:=BlockArray[1,2].Group;
    BlockArray[1+(X*xa),2+(Y*z)].Color:=BlockArray[1,2].Color;
    BlockArray[1+(X*xa),3+(Y*z)].Group:=BlockArray[1,3].Group;
    BlockArray[1+(X*xa),3+(Y*z)].Color:=BlockArray[1,3].Color;
    BlockArray[1+(X*xa),4+(Y*z)].Group:=BlockArray[1,4].Group;
    BlockArray[1+(X*xa),4+(Y*z)].Color:=BlockArray[1,4].Color;
    BlockArray[1+(X*xa),5+(Y*z)].Group:=BlockArray[1,5].Group;
    BlockArray[1+(X*xa),5+(Y*z)].Color:=BlockArray[1,5].Color;
    BlockArray[1+(X*xa),6+(Y*z)].Group:=BlockArray[1,6].Group;
    BlockArray[1+(X*xa),6+(Y*z)].Color:=BlockArray[1,6].Color;
    BlockArray[1+(X*xa),7+(Y*z)].Group:=BlockArray[1,7].Group;
    BlockArray[1+(X*xa),7+(Y*z)].Color:=BlockArray[1,7].Color;
    BlockArray[1+(X*xa),8+(Y*z)].Group:=BlockArray[1,8].Group;
    BlockArray[1+(X*xa),8+(Y*z)].Color:=BlockArray[1,8].Color;
    BlockArray[1+(X*xa),9+(Y*z)].Group:=BlockArray[1,9].Group;
    BlockArray[1+(X*xa),9+(Y*z)].Color:=BlockArray[1,9].Color;
    BlockArray[1+(X*xa),10+(Y*z)].Group:=BlockArray[1,10].Group;
    BlockArray[1+(X*xa),10+(Y*z)].Color:=BlockArray[1,10].Color;
    BlockArray[1+(X*xa),11+(Y*z)].Group:=BlockArray[1,11].Group;
    BlockArray[1+(X*xa),11+(Y*z)].Color:=BlockArray[1,11].Color;
    BlockArray[1+(X*xa),12+(Y*z)].Group:=BlockArray[1,12].Group;
    BlockArray[1+(X*xa),12+(Y*z)].Color:=BlockArray[1,12].Color;
    If y=3 then begin
    BlockArray[1+(X*xa),13+(Y*z)].Group:=BlockArray[1,13].Group;
    BlockArray[1+(X*xa),13+(Y*z)].Color:=BlockArray[1,13].Color;
    end;
    If x=2 then begin
    BlockArray[5+(X*7),2+(Y*z)].Group:=BlockArray[1,2].Group;
    BlockArray[5+(X*7),2+(Y*z)].Color:=BlockArray[1,2].Color;
    BlockArray[5+(X*7),4+(Y*z)].Group:=BlockArray[1,4].Group;
    BlockArray[5+(X*7),4+(Y*z)].Color:=BlockArray[1,4].Color;
    BlockArray[5+(X*7),6+(Y*z)].Group:=BlockArray[1,6].Group;
    BlockArray[5+(X*7),6+(Y*z)].Color:=BlockArray[1,6].Color;
    BlockArray[5+(X*7),8+(Y*z)].Group:=BlockArray[1,8].Group;
    BlockArray[5+(X*7),8+(Y*z)].Color:=BlockArray[1,8].Color;
    BlockArray[5+(X*7),10+(Y*z)].Group:=BlockArray[1,10].Group;
    BlockArray[5+(X*7),10+(Y*z)].Color:=BlockArray[1,10].Color;
    BlockArray[5+(X*7),12+(Y*z)].Group:=BlockArray[1,12].Group;
    BlockArray[5+(X*7),12+(Y*z)].Color:=BlockArray[1,12].Color;
    end;

    BlockArray[2+(X*xa),1+(Y*z)].Group:=BlockArray[2,1].Group;
    BlockArray[2+(X*xa),1+(Y*z)].Color:=BlockArray[2,1].Color;
    BlockArray[2+(X*xa),2+(Y*z)].Group:=BlockArray[2,2].Group;
    BlockArray[2+(X*xa),2+(Y*z)].Color:=BlockArray[2,2].Color;
    BlockArray[2+(X*xa),3+(Y*z)].Group:=BlockArray[2,3].Group;
    BlockArray[2+(X*xa),3+(Y*z)].Color:=BlockArray[2,3].Color;
    BlockArray[2+(X*xa),4+(Y*z)].Group:=BlockArray[2,4].Group;
    BlockArray[2+(X*xa),4+(Y*z)].Color:=BlockArray[2,4].Color;
    BlockArray[2+(X*xa),5+(Y*z)].Group:=BlockArray[2,5].Group;
    BlockArray[2+(X*xa),5+(Y*z)].Color:=BlockArray[2,5].Color;
    BlockArray[2+(X*xa),6+(Y*z)].Group:=BlockArray[2,6].Group;
    BlockArray[2+(X*xa),6+(Y*z)].Color:=BlockArray[2,6].Color;
    BlockArray[2+(X*xa),7+(Y*z)].Group:=BlockArray[2,7].Group;
    BlockArray[2+(X*xa),7+(Y*z)].Color:=BlockArray[2,7].Color;
    BlockArray[2+(X*xa),8+(Y*z)].Group:=BlockArray[2,8].Group;
    BlockArray[2+(X*xa),8+(Y*z)].Color:=BlockArray[2,8].Color;
    BlockArray[2+(X*xa),9+(Y*z)].Group:=BlockArray[2,9].Group;
    BlockArray[2+(X*xa),9+(Y*z)].Color:=BlockArray[2,9].Color;
    BlockArray[2+(X*xa),10+(Y*z)].Group:=BlockArray[2,10].Group;
    BlockArray[2+(X*xa),10+(Y*z)].Color:=BlockArray[2,10].Color;
    BlockArray[2+(X*xa),11+(Y*z)].Group:=BlockArray[2,11].Group;
    BlockArray[2+(X*xa),11+(Y*z)].Color:=BlockArray[2,11].Color;
    BlockArray[2+(X*xa),12+(Y*z)].Group:=BlockArray[2,12].Group;
    BlockArray[2+(X*xa),12+(Y*z)].Color:=BlockArray[2,12].Color;
    If y=3 then begin
    BlockArray[2+(X*xa),13+(Y*z)].Group:=BlockArray[2,13].Group;
    BlockArray[2+(X*xa),13+(Y*z)].Color:=BlockArray[2,13].Color;
    end;

    BlockArray[3+(X*xa),1+(Y*z)].Group:=BlockArray[3,1].Group;
    BlockArray[3+(X*xa),1+(Y*z)].Color:=BlockArray[3,1].Color;
    BlockArray[3+(X*xa),2+(Y*z)].Group:=BlockArray[3,2].Group;
    BlockArray[3+(X*xa),2+(Y*z)].Color:=BlockArray[3,2].Color;
    BlockArray[3+(X*xa),3+(Y*z)].Group:=BlockArray[3,3].Group;
    BlockArray[3+(X*xa),3+(Y*z)].Color:=BlockArray[3,3].Color;
    BlockArray[3+(X*xa),4+(Y*z)].Group:=BlockArray[3,4].Group;
    BlockArray[3+(X*xa),4+(Y*z)].Color:=BlockArray[3,4].Color;
    BlockArray[3+(X*xa),5+(Y*z)].Group:=BlockArray[3,5].Group;
    BlockArray[3+(X*xa),5+(Y*z)].Color:=BlockArray[3,5].Color;
    BlockArray[3+(X*xa),6+(Y*z)].Group:=BlockArray[3,6].Group;
    BlockArray[3+(X*xa),6+(Y*z)].Color:=BlockArray[3,6].Color;
    BlockArray[3+(X*xa),7+(Y*z)].Group:=BlockArray[3,7].Group;
    BlockArray[3+(X*xa),7+(Y*z)].Color:=BlockArray[3,7].Color;
    BlockArray[3+(X*xa),8+(Y*z)].Group:=BlockArray[3,8].Group;
    BlockArray[3+(X*xa),8+(Y*z)].Color:=BlockArray[3,8].Color;
    BlockArray[3+(X*xa),9+(Y*z)].Group:=BlockArray[3,9].Group;
    BlockArray[3+(X*xa),9+(Y*z)].Color:=BlockArray[3,9].Color;
    BlockArray[3+(X*xa),10+(Y*z)].Group:=BlockArray[3,10].Group;
    BlockArray[3+(X*xa),10+(Y*z)].Color:=BlockArray[3,10].Color;
    BlockArray[3+(X*xa),11+(Y*z)].Group:=BlockArray[3,11].Group;
    BlockArray[3+(X*xa),11+(Y*z)].Color:=BlockArray[3,11].Color;
    BlockArray[3+(X*xa),12+(Y*z)].Group:=BlockArray[3,12].Group;
    BlockArray[3+(X*xa),12+(Y*z)].Color:=BlockArray[3,12].Color;
    If y=3 then begin
    BlockArray[3+(X*xa),13+(Y*z)].Group:=BlockArray[3,13].Group;
    BlockArray[3+(X*xa),13+(Y*z)].Color:=BlockArray[3,13].Color;
    end;

    BlockArray[4+(X*xa),1+(Y*z)].Group:=BlockArray[4,1].Group;
    BlockArray[4+(X*xa),1+(Y*z)].Color:=BlockArray[4,1].Color;
    BlockArray[4+(X*xa),2+(Y*z)].Group:=BlockArray[4,2].Group;
    BlockArray[4+(X*xa),2+(Y*z)].Color:=BlockArray[4,2].Color;
    BlockArray[4+(X*xa),3+(Y*z)].Group:=BlockArray[4,3].Group;
    BlockArray[4+(X*xa),3+(Y*z)].Color:=BlockArray[4,3].Color;
    BlockArray[4+(X*xa),4+(Y*z)].Group:=BlockArray[4,4].Group;
    BlockArray[4+(X*xa),4+(Y*z)].Color:=BlockArray[4,4].Color;
    BlockArray[4+(X*xa),5+(Y*z)].Group:=BlockArray[4,5].Group;
    BlockArray[4+(X*xa),5+(Y*z)].Color:=BlockArray[4,5].Color;
    BlockArray[4+(X*xa),6+(Y*z)].Group:=BlockArray[4,6].Group;
    BlockArray[4+(X*xa),6+(Y*z)].Color:=BlockArray[4,6].Color;
    BlockArray[4+(X*xa),7+(Y*z)].Group:=BlockArray[4,7].Group;
    BlockArray[4+(X*xa),7+(Y*z)].Color:=BlockArray[4,7].Color;
    BlockArray[4+(X*xa),8+(Y*z)].Group:=BlockArray[4,8].Group;
    BlockArray[4+(X*xa),8+(Y*z)].Color:=BlockArray[4,8].Color;
    BlockArray[4+(X*xa),9+(Y*z)].Group:=BlockArray[4,9].Group;
    BlockArray[4+(X*xa),9+(Y*z)].Color:=BlockArray[4,9].Color;
    BlockArray[4+(X*xa),10+(Y*z)].Group:=BlockArray[4,10].Group;
    BlockArray[4+(X*xa),10+(Y*z)].Color:=BlockArray[4,10].Color;
    BlockArray[4+(X*xa),11+(Y*z)].Group:=BlockArray[4,11].Group;
    BlockArray[4+(X*xa),11+(Y*z)].Color:=BlockArray[4,11].Color;
    BlockArray[4+(X*xa),12+(Y*z)].Group:=BlockArray[4,12].Group;
    BlockArray[4+(X*xa),12+(Y*z)].Color:=BlockArray[4,12].Color;
    If y=3 then begin
    BlockArray[4+(X*xa),13+(Y*z)].Group:=BlockArray[4,13].Group;
    BlockArray[4+(X*xa),13+(Y*z)].Color:=BlockArray[4,13].Color;
    end;

    BlockArray[5+(X*xa),1+(Y*z)].Group:=BlockArray[5,1].Group;
    BlockArray[5+(X*xa),1+(Y*z)].Color:=BlockArray[5,1].Color;
    BlockArray[5+(X*xa),2+(Y*z)].Group:=BlockArray[5,2].Group;
    BlockArray[5+(X*xa),2+(Y*z)].Color:=BlockArray[5,2].Color;
    BlockArray[5+(X*xa),3+(Y*z)].Group:=BlockArray[5,3].Group;
    BlockArray[5+(X*xa),3+(Y*z)].Color:=BlockArray[5,3].Color;
    BlockArray[5+(X*xa),4+(Y*z)].Group:=BlockArray[5,4].Group;
    BlockArray[5+(X*xa),4+(Y*z)].Color:=BlockArray[5,4].Color;
    BlockArray[5+(X*xa),5+(Y*z)].Group:=BlockArray[5,5].Group;
    BlockArray[5+(X*xa),5+(Y*z)].Color:=BlockArray[5,5].Color;
    BlockArray[5+(X*xa),6+(Y*z)].Group:=BlockArray[5,6].Group;
    BlockArray[5+(X*xa),6+(Y*z)].Color:=BlockArray[5,6].Color;
    BlockArray[5+(X*xa),7+(Y*z)].Group:=BlockArray[5,7].Group;
    BlockArray[5+(X*xa),7+(Y*z)].Color:=BlockArray[5,7].Color;
    BlockArray[5+(X*xa),8+(Y*z)].Group:=BlockArray[5,8].Group;
    BlockArray[5+(X*xa),8+(Y*z)].Color:=BlockArray[5,8].Color;
    BlockArray[5+(X*xa),9+(Y*z)].Group:=BlockArray[5,9].Group;
    BlockArray[5+(X*xa),9+(Y*z)].Color:=BlockArray[5,9].Color;
    BlockArray[5+(X*xa),10+(Y*z)].Group:=BlockArray[5,10].Group;
    BlockArray[5+(X*xa),10+(Y*z)].Color:=BlockArray[5,10].Color;
    BlockArray[5+(X*xa),11+(Y*z)].Group:=BlockArray[5,11].Group;
    BlockArray[5+(X*xa),11+(Y*z)].Color:=BlockArray[5,11].Color;
    BlockArray[5+(X*xa),12+(Y*z)].Group:=BlockArray[5,12].Group;
    BlockArray[5+(X*xa),12+(Y*z)].Color:=BlockArray[5,12].Color;
    If y=3 then begin
    BlockArray[5+(X*xa),13+(Y*z)].Group:=BlockArray[5,13].Group;
    BlockArray[5+(X*xa),13+(Y*z)].Color:=BlockArray[5,13].Color;
    end;

    BlockArray[6+(X*xa),1+(Y*z)].Group:=BlockArray[6,1].Group;
    BlockArray[6+(X*xa),1+(Y*z)].Color:=BlockArray[6,1].Color;
    BlockArray[6+(X*xa),2+(Y*z)].Group:=BlockArray[6,2].Group;
    BlockArray[6+(X*xa),2+(Y*z)].Color:=BlockArray[6,2].Color;
    BlockArray[6+(X*xa),3+(Y*z)].Group:=BlockArray[6,3].Group;
    BlockArray[6+(X*xa),3+(Y*z)].Color:=BlockArray[6,3].Color;
    BlockArray[6+(X*xa),4+(Y*z)].Group:=BlockArray[6,4].Group;
    BlockArray[6+(X*xa),4+(Y*z)].Color:=BlockArray[6,4].Color;
    BlockArray[6+(X*xa),5+(Y*z)].Group:=BlockArray[6,5].Group;
    BlockArray[6+(X*xa),5+(Y*z)].Color:=BlockArray[6,5].Color;
    BlockArray[6+(X*xa),6+(Y*z)].Group:=BlockArray[6,6].Group;
    BlockArray[6+(X*xa),6+(Y*z)].Color:=BlockArray[6,6].Color;
    BlockArray[6+(X*xa),7+(Y*z)].Group:=BlockArray[6,7].Group;
    BlockArray[6+(X*xa),7+(Y*z)].Color:=BlockArray[6,7].Color;
    BlockArray[6+(X*xa),8+(Y*z)].Group:=BlockArray[6,8].Group;
    BlockArray[6+(X*xa),8+(Y*z)].Color:=BlockArray[6,8].Color;
    BlockArray[6+(X*xa),9+(Y*z)].Group:=BlockArray[6,9].Group;
    BlockArray[6+(X*xa),9+(Y*z)].Color:=BlockArray[6,9].Color;
    BlockArray[6+(X*xa),10+(Y*z)].Group:=BlockArray[6,10].Group;
    BlockArray[6+(X*xa),10+(Y*z)].Color:=BlockArray[6,10].Color;
    BlockArray[6+(X*xa),11+(Y*z)].Group:=BlockArray[6,11].Group;
    BlockArray[6+(X*xa),11+(Y*z)].Color:=BlockArray[6,11].Color;
    BlockArray[6+(X*xa),12+(Y*z)].Group:=BlockArray[6,12].Group;
    BlockArray[6+(X*xa),12+(Y*z)].Color:=BlockArray[6,12].Color;
    If y=3 then begin
    BlockArray[6+(X*xa),13+(Y*z)].Group:=BlockArray[6,13].Group;
    BlockArray[6+(X*xa),13+(Y*z)].Color:=BlockArray[6,13].Color;
    end;

(*    BlockArray[7+(X*z),1+(Y*z)].Group:=BlockArray[7,1].Group;
    BlockArray[7+(X*z),1+(Y*z)].Color:=BlockArray[7,1].Color;
    BlockArray[7+(X*z),2+(Y*z)].Group:=BlockArray[7,2].Group;
    BlockArray[7+(X*z),2+(Y*z)].Color:=BlockArray[7,2].Color;
    BlockArray[7+(X*z),3+(Y*z)].Group:=BlockArray[7,3].Group;
    BlockArray[7+(X*z),3+(Y*z)].Color:=BlockArray[7,3].Color;
    BlockArray[7+(X*z),4+(Y*z)].Group:=BlockArray[7,4].Group;
    BlockArray[7+(X*z),4+(Y*z)].Color:=BlockArray[7,4].Color;
    BlockArray[7+(X*z),5+(Y*z)].Group:=BlockArray[7,5].Group;
    BlockArray[7+(X*z),5+(Y*z)].Color:=BlockArray[7,5].Color;
    BlockArray[7+(X*z),6+(Y*z)].Group:=BlockArray[7,6].Group;
    BlockArray[7+(X*z),6+(Y*z)].Color:=BlockArray[7,6].Color;
    BlockArray[7+(X*z),7+(Y*z)].Group:=BlockArray[7,7].Group;
    BlockArray[7+(X*z),7+(Y*z)].Color:=BlockArray[7,7].Color;
    BlockArray[7+(X*z),8+(Y*z)].Group:=BlockArray[7,8].Group;
    BlockArray[7+(X*z),8+(Y*z)].Color:=BlockArray[7,8].Color;
    BlockArray[7+(X*z),9+(Y*z)].Group:=BlockArray[7,9].Group;
    BlockArray[7+(X*z),9+(Y*z)].Color:=BlockArray[7,9].Color;
    BlockArray[7+(X*z),10+(Y*z)].Group:=BlockArray[7,10].Group;
    BlockArray[7+(X*z),10+(Y*z)].Color:=BlockArray[7,10].Color;
    BlockArray[7+(X*z),11+(Y*z)].Group:=BlockArray[7,11].Group;
    BlockArray[7+(X*z),11+(Y*z)].Color:=BlockArray[7,11].Color;
    BlockArray[7+(X*z),12+(Y*z)].Group:=BlockArray[7,12].Group;
    BlockArray[7+(X*z),12+(Y*z)].Color:=BlockArray[7,12].Color;


    BlockArray[8+(X*z),1+(Y*z)].Group:=BlockArray[8,1].Group;
    BlockArray[8+(X*z),1+(Y*z)].Color:=BlockArray[8,1].Color;
    BlockArray[8+(X*z),2+(Y*z)].Group:=BlockArray[8,2].Group;
    BlockArray[8+(X*z),2+(Y*z)].Color:=BlockArray[8,2].Color;
    BlockArray[8+(X*z),3+(Y*z)].Group:=BlockArray[8,3].Group;
    BlockArray[8+(X*z),3+(Y*z)].Color:=BlockArray[8,3].Color;
    BlockArray[8+(X*z),4+(Y*z)].Group:=BlockArray[8,4].Group;
    BlockArray[8+(X*z),4+(Y*z)].Color:=BlockArray[8,4].Color;
    BlockArray[8+(X*z),5+(Y*z)].Group:=BlockArray[8,5].Group;
    BlockArray[8+(X*z),5+(Y*z)].Color:=BlockArray[8,5].Color;
    BlockArray[8+(X*z),6+(Y*z)].Group:=BlockArray[8,6].Group;
    BlockArray[8+(X*z),6+(Y*z)].Color:=BlockArray[8,6].Color;
    BlockArray[8+(X*z),7+(Y*z)].Group:=BlockArray[8,7].Group;
    BlockArray[8+(X*z),7+(Y*z)].Color:=BlockArray[8,7].Color;
    BlockArray[8+(X*z),8+(Y*z)].Group:=BlockArray[8,8].Group;
    BlockArray[8+(X*z),8+(Y*z)].Color:=BlockArray[8,8].Color;
    BlockArray[8+(X*z),9+(Y*z)].Group:=BlockArray[8,9].Group;
    BlockArray[8+(X*z),9+(Y*z)].Color:=BlockArray[8,9].Color;
    BlockArray[8+(X*z),10+(Y*z)].Group:=BlockArray[8,10].Group;
    BlockArray[8+(X*z),10+(Y*z)].Color:=BlockArray[8,10].Color;
    BlockArray[8+(X*z),11+(Y*z)].Group:=BlockArray[8,11].Group;
    BlockArray[8+(X*z),11+(Y*z)].Color:=BlockArray[8,11].Color;
    BlockArray[8+(X*z),12+(Y*z)].Group:=BlockArray[8,12].Group;
    BlockArray[8+(X*z),12+(Y*z)].Color:=BlockArray[8,12].Color;

    BlockArray[9+(X*z),1+(Y*z)].Group:=BlockArray[9,1].Group;
    BlockArray[9+(X*z),1+(Y*z)].Color:=BlockArray[9,1].Color;
    BlockArray[9+(X*z),2+(Y*z)].Group:=BlockArray[9,2].Group;
    BlockArray[9+(X*z),2+(Y*z)].Color:=BlockArray[9,2].Color;
    BlockArray[9+(X*z),3+(Y*z)].Group:=BlockArray[9,3].Group;
    BlockArray[9+(X*z),3+(Y*z)].Color:=BlockArray[9,3].Color;
    BlockArray[9+(X*z),4+(Y*z)].Group:=BlockArray[9,4].Group;
    BlockArray[9+(X*z),4+(Y*z)].Color:=BlockArray[9,4].Color;
    BlockArray[9+(X*z),5+(Y*z)].Group:=BlockArray[9,5].Group;
    BlockArray[9+(X*z),5+(Y*z)].Color:=BlockArray[9,5].Color;
    BlockArray[9+(X*z),6+(Y*z)].Group:=BlockArray[9,6].Group;
    BlockArray[9+(X*z),6+(Y*z)].Color:=BlockArray[9,6].Color;
    BlockArray[9+(X*z),7+(Y*z)].Group:=BlockArray[9,7].Group;
    BlockArray[9+(X*z),7+(Y*z)].Color:=BlockArray[9,7].Color;
    BlockArray[9+(X*z),8+(Y*z)].Group:=BlockArray[9,8].Group;
    BlockArray[9+(X*z),8+(Y*z)].Color:=BlockArray[9,8].Color;
    BlockArray[9+(X*z),9+(Y*z)].Group:=BlockArray[9,9].Group;
    BlockArray[9+(X*z),9+(Y*z)].Color:=BlockArray[9,9].Color;
    BlockArray[9+(X*z),10+(Y*z)].Group:=BlockArray[9,10].Group;
    BlockArray[9+(X*z),10+(Y*z)].Color:=BlockArray[9,10].Color;
    BlockArray[9+(X*z),11+(Y*z)].Group:=BlockArray[9,11].Group;
    BlockArray[9+(X*z),11+(Y*z)].Color:=BlockArray[9,11].Color;
    BlockArray[9+(X*z),12+(Y*z)].Group:=BlockArray[9,12].Group;
    BlockArray[9+(X*z),12+(Y*z)].Color:=BlockArray[9,12].Color;

    BlockArray[10+(X*z),1+(Y*z)].Group:=BlockArray[10,1].Group;
    BlockArray[10+(X*z),1+(Y*z)].Color:=BlockArray[10,1].Color;
    BlockArray[10+(X*z),2+(Y*z)].Group:=BlockArray[10,2].Group;
    BlockArray[10+(X*z),2+(Y*z)].Color:=BlockArray[10,2].Color;
    BlockArray[10+(X*z),3+(Y*z)].Group:=BlockArray[10,3].Group;
    BlockArray[10+(X*z),3+(Y*z)].Color:=BlockArray[10,3].Color;
    BlockArray[10+(X*z),4+(Y*z)].Group:=BlockArray[10,4].Group;
    BlockArray[10+(X*z),4+(Y*z)].Color:=BlockArray[10,4].Color;
    BlockArray[10+(X*z),5+(Y*z)].Group:=BlockArray[10,5].Group;
    BlockArray[10+(X*z),5+(Y*z)].Color:=BlockArray[10,5].Color;
    BlockArray[10+(X*z),6+(Y*z)].Group:=BlockArray[10,6].Group;
    BlockArray[10+(X*z),6+(Y*z)].Color:=BlockArray[10,6].Color;
    BlockArray[10+(X*z),7+(Y*z)].Group:=BlockArray[10,7].Group;
    BlockArray[10+(X*z),7+(Y*z)].Color:=BlockArray[10,7].Color;
    BlockArray[10+(X*z),8+(Y*z)].Group:=BlockArray[10,8].Group;
    BlockArray[10+(X*z),8+(Y*z)].Color:=BlockArray[10,8].Color;
    BlockArray[10+(X*z),9+(Y*z)].Group:=BlockArray[10,9].Group;
    BlockArray[10+(X*z),9+(Y*z)].Color:=BlockArray[10,9].Color;
    BlockArray[10+(X*z),10+(Y*z)].Group:=BlockArray[10,10].Group;
    BlockArray[10+(X*z),10+(Y*z)].Color:=BlockArray[10,10].Color;
    BlockArray[10+(X*z),11+(Y*z)].Group:=BlockArray[10,11].Group;
    BlockArray[10+(X*z),11+(Y*z)].Color:=BlockArray[10,11].Color;
    BlockArray[10+(X*z),12+(Y*z)].Group:=BlockArray[10,12].Group;
    BlockArray[10+(X*z),12+(Y*z)].Color:=BlockArray[10,12].Color;

    BlockArray[11+(X*z),1+(Y*z)].Group:=BlockArray[11,1].Group;
    BlockArray[11+(X*z),1+(Y*z)].Color:=BlockArray[11,1].Color;
    BlockArray[11+(X*z),2+(Y*z)].Group:=BlockArray[11,2].Group;
    BlockArray[11+(X*z),2+(Y*z)].Color:=BlockArray[11,2].Color;
    BlockArray[11+(X*z),3+(Y*z)].Group:=BlockArray[11,3].Group;
    BlockArray[11+(X*z),3+(Y*z)].Color:=BlockArray[11,3].Color;
    BlockArray[11+(X*z),4+(Y*z)].Group:=BlockArray[11,4].Group;
    BlockArray[11+(X*z),4+(Y*z)].Color:=BlockArray[11,4].Color;
    BlockArray[11+(X*z),5+(Y*z)].Group:=BlockArray[11,5].Group;
    BlockArray[11+(X*z),5+(Y*z)].Color:=BlockArray[11,5].Color;
    BlockArray[11+(X*z),6+(Y*z)].Group:=BlockArray[11,6].Group;
    BlockArray[11+(X*z),6+(Y*z)].Color:=BlockArray[11,6].Color;
    BlockArray[11+(X*z),7+(Y*z)].Group:=BlockArray[11,7].Group;
    BlockArray[11+(X*z),7+(Y*z)].Color:=BlockArray[11,7].Color;
    BlockArray[11+(X*z),8+(Y*z)].Group:=BlockArray[11,8].Group;
    BlockArray[11+(X*z),8+(Y*z)].Color:=BlockArray[11,8].Color;
    BlockArray[11+(X*z),9+(Y*z)].Group:=BlockArray[11,9].Group;
    BlockArray[11+(X*z),9+(Y*z)].Color:=BlockArray[11,9].Color;
    BlockArray[11+(X*z),10+(Y*z)].Group:=BlockArray[11,10].Group;
    BlockArray[11+(X*z),10+(Y*z)].Color:=BlockArray[11,10].Color;
    BlockArray[11+(X*z),11+(Y*z)].Group:=BlockArray[11,11].Group;
    BlockArray[11+(X*z),11+(Y*z)].Color:=BlockArray[11,11].Color;
    BlockArray[11+(X*z),12+(Y*z)].Group:=BlockArray[11,12].Group;
    BlockArray[11+(X*z),12+(Y*z)].Color:=BlockArray[11,12].Color;

    BlockArray[12+(X*z),1+(Y*z)].Group:=BlockArray[12,1].Group;
    BlockArray[12+(X*z),1+(Y*z)].Color:=BlockArray[12,1].Color;
    BlockArray[12+(X*z),2+(Y*z)].Group:=BlockArray[12,2].Group;
    BlockArray[12+(X*z),2+(Y*z)].Color:=BlockArray[12,2].Color;
    BlockArray[12+(X*z),3+(Y*z)].Group:=BlockArray[12,3].Group;
    BlockArray[12+(X*z),3+(Y*z)].Color:=BlockArray[12,3].Color;
    BlockArray[12+(X*z),4+(Y*z)].Group:=BlockArray[12,4].Group;
    BlockArray[12+(X*z),4+(Y*z)].Color:=BlockArray[12,4].Color;
    BlockArray[12+(X*z),5+(Y*z)].Group:=BlockArray[12,5].Group;
    BlockArray[12+(X*z),5+(Y*z)].Color:=BlockArray[12,5].Color;
    BlockArray[12+(X*z),6+(Y*z)].Group:=BlockArray[12,6].Group;
    BlockArray[12+(X*z),6+(Y*z)].Color:=BlockArray[12,6].Color;
    BlockArray[12+(X*z),7+(Y*z)].Group:=BlockArray[12,7].Group;
    BlockArray[12+(X*z),7+(Y*z)].Color:=BlockArray[12,7].Color;
    BlockArray[12+(X*z),8+(Y*z)].Group:=BlockArray[12,8].Group;
    BlockArray[12+(X*z),8+(Y*z)].Color:=BlockArray[12,8].Color;
    BlockArray[12+(X*z),9+(Y*z)].Group:=BlockArray[12,9].Group;
    BlockArray[12+(X*z),9+(Y*z)].Color:=BlockArray[12,9].Color;
    BlockArray[12+(X*z),10+(Y*z)].Group:=BlockArray[12,10].Group;
    BlockArray[12+(X*z),10+(Y*z)].Color:=BlockArray[12,10].Color;
    BlockArray[12+(X*z),11+(Y*z)].Group:=BlockArray[12,11].Group;
    BlockArray[12+(X*z),11+(Y*z)].Color:=BlockArray[12,11].Color;
    BlockArray[12+(X*z),12+(Y*z)].Group:=BlockArray[12,12].Group;
    BlockArray[12+(X*z),12+(Y*z)].Color:=BlockArray[12,12].Color;*)
    end;
  end;
  PaintAllBlocks;
end;
       
procedure TCatWinForm.FormResize(Sender: TObject);
begin
  PaintAllBlocks;
end;





procedure TCatWinForm.ChangeBtnClick(Sender: TObject);
var  x,y,i,keeper: Integer;
begin
  If GroupListBox.Items.Count > 1 then
  begin
    keeper:=0;
    for i := 0 to (GroupListBox.Items.Count - 1) do
    begin
      try
        if GroupListBox.Selected[i] then
        begin
          keeper:=i;
          CatList[i]:= inttostr(ChangePanel.Color);
          GroupListBox.Items[keeper]:= ChangeEdit.Text;
          break;
        end;
      finally
        { do something here }
      end;
    end;
    {Repaint All Blocks...}
    If keeper > 0 then
    begin
    For X:=1 to 19 do begin
    For Y:= 1 to 49 do
    If keeper = BlockArray[X,Y].Group then
    Begin
      BlockArray[X,Y].Color:=strtoint(CatList[keeper]);
    End; end;
    PaintAllBlocks;
    ColorPanel.Color:=  strtoint(CatList[keeper]);
    AddEdit.Text:=    GroupListBox.Items[keeper];
    GroupListBox.ItemIndex:=keeper;
    end;
  end;
end;

procedure TCatWinForm.ChangePanelClick(Sender: TObject);
begin
  ColorDialog1.Color:= ChangePanel.Color;
  if ColorDialog1.Execute then
  begin
    ChangePanel.Color := ColorDialog1.Color;
  end;
end;



procedure TCatWinForm.Recrunch1Click(Sender: TObject);
var  x,y,i,keeper,keeperColor: Integer;
begin
  If GroupListBox.Items.Count > 1 then
  begin
    keeper:=0;  keeperColor:=0;
    for i := 0 to (GroupListBox.Items.Count - 1) do
    begin
      try
        if GroupListBox.Selected[i] then
        begin
          keeper:=i;
          keeperColor:=strtoint(CatList[i]);
          break;
        end;
      finally
        { do something here }
      end;
    end;
    {Repaint All Blocks...}
    If keeper > 0 then
    begin
    For X:=1 to 19 do begin           
    For Y:= 1 to 49 do
    If keeperColor = BlockArray[X,Y].Color then
    Begin
      BlockArray[X,Y].Group:=keeper;
    End; end;
    PaintAllBlocks;
    ColorPanel.Color:=  strtoint(CatList[keeper]);
    AddEdit.Text:=    GroupListBox.Items[keeper];
    GroupListBox.ItemIndex:=keeper;
    end;
  end;
end;
///////////////////////////////////////////////////
///////////////////////////////////////////////////


///////////////////////////////////////////////////
///////////////////////////////////////////////////


///////////////////////////////////////////////////
///////////////////////////////////////////////////
procedure TCatWinForm.ShowSquareMaker1Click(Sender: TObject);
begin
  ShowSquareMaker1.Checked := (not ShowSquareMaker1.Checked );
  If ShowSquareMaker1.Checked then
  begin
    {CatWinForm Resize}
    //showmessage('ok');
    MainPanel.Align:=alNone;
    BlockDuplicatesPanel.Align:=alNone;
    CatWinForm.Width:= 496;
    CatWinForm.Height:= 545;
    MainPanel.Left:=191;
    MainPanel.Width:=112;
    //showmessage('ok 2');
    BlockDuplicatesPanel.Width:=185;
    BlockDuplicatesPanel.Visible:=True;
    BlockDuplicatesPanel.Align:=alRight;
    MainPanel.Align:=alRight;
  end else
  begin
    MainPanel.Align:=alNone;
    BlockDuplicatesPanel.Align:=alNone;
    BlockDuplicatesPanel.Visible:=False;
    MainPanel.Left:=191;
    MainPanel.Width:=112;
    CatWinForm.Width:= 311;//(496-185);
    CatWinForm.Height:= 545;
    MainPanel.Align:=alRight;
  end;
end;

procedure TCatWinForm.ImageQB321MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer;
  Layer: TCustomLayer);
var xb,yb:Integer;
begin
  If VerifyBlock1.Checked then
  begin
    VerificationEdit.Text:=
     GroupListBox.Items[QBBlockArray[(X div 10)+1,(Y div 10)+1].Group];
    {Inttostr(BlockArray[(X div 10)+1,(Y div 10)+1].Group);}
    VerificationPanel.Color:=QBBlockArray[(X div 10)+1,(Y div 10)+1].Color;
  end else
  If Block1.Checked then
  begin
    QBBlockArray[(X div 10)+1,(Y div 10)+1].Color:=ColorPanel.Color;
    QBBlockArray[(X div 10)+1,(Y div 10)+1].Group:=GroupListBox.ItemIndex;
  end else
  If Column1.Checked then
  begin
    For Yb:= 1 to 13 do
    begin
      if ((x mod 10) =0) then
      begin
        if ((yb mod 2) =0) then
        begin
          QBBlockArray[(X div 10)+1,Yb].Color:=ColorPanel.Color;
          QBBlockArray[(X div 10)+1,Yb].Group:=GroupListBox.ItemIndex;
        end;
      end else
      begin
        if ((yb mod 2) <>0) then
        begin
          QBBlockArray[(X div 10)+1,Yb].Color:=ColorPanel.Color;
           QBBlockArray[(X div 10)+1,Yb].Group:=GroupListBox.ItemIndex;
        end;
      end;
    end;
  end else
  If Row1.Checked then
  begin
    For Xb:=1 to 7 do
    begin
      QBBlockArray[(Xb),(Y div 10)+1].Color:=ColorPanel.Color;
      QBBlockArray[(Xb),(Y div 10)+1].Group:=GroupListBox.ItemIndex;
    end;
  end else
  If Flake1.Checked then
  begin
    if (((Y div 10) mod 2) =0) then
    begin
      QBBlockArray[(X div 10)-1,(Y div 10)+1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)-1,(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10),(Y div 10)+1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+1,(Y div 10)+1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+2,(Y div 10)+1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+3,(Y div 10)+1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+3,(Y div 10)+1].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10)+2,(Y div 10)+2].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)+2].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+2,(Y div 10)+3].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)+3].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+2,(Y div 10)].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+2,(Y div 10)-1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)-1].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10)+1,(Y div 10)+2].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)+2].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10),(Y div 10)+3].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)+3].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+1,(Y div 10)].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10),(Y div 10)-1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)-1].Group:=GroupListBox.ItemIndex;
    end else
    begin
      QBBlockArray[(X div 10)-1,(Y div 10)+1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)-1,(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10),(Y div 10)+1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+1,(Y div 10)+1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+2,(Y div 10)+1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+3,(Y div 10)+1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+3,(Y div 10)+1].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10)+1,(Y div 10)+2].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)+2].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+2,(Y div 10)+3].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)+3].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+1,(Y div 10)].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+2,(Y div 10)-1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)-1].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10),(Y div 10)+2].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)+2].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10),(Y div 10)+3].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)+3].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10),(Y div 10)].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10),(Y div 10)-1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)-1].Group:=GroupListBox.ItemIndex;
    end
  end else
  If Diamond1.Checked then
  begin
    if (((Y div 10) mod 2) =0) then
    begin
      QBBlockArray[(X div 10),(Y div 10)+1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+2,(Y div 10)+1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+1,(Y div 10)+1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)+1].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10)+1,(Y div 10)].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+2,(Y div 10)].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10)+1,(Y div 10)+2].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)+2].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+2,(Y div 10)+2].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)+2].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10)+1,(Y div 10)-1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)-1].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+1,(Y div 10)+3].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)+3].Group:=GroupListBox.ItemIndex;
    end else
    begin
      QBBlockArray[(X div 10),(Y div 10)+1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+2,(Y div 10)+1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)+1].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+1,(Y div 10)+1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)+1].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10),(Y div 10)].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+1,(Y div 10)].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10)+1,(Y div 10)+2].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)+2].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10),(Y div 10)+2].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)+2].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10)+1,(Y div 10)-1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)-1].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+1,(Y div 10)+3].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)+3].Group:=GroupListBox.ItemIndex;
    end;
  end else
  If TwoToneStar.Checked then
  begin
  {          DblFillPanel.Color:=  strtoint(CatList[i]);
          DblFillEdit.Text:=    GroupListBox.Items[i];
          DblFillEdit2.Text:=    inttostr(i);  }
    if (((Y div 10) mod 2) =0) then
    begin
      QBBlockArray[(X div 10),(Y div 10)+1].Color:=DblFillPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)+1].Group:=strtoint(DblFillEdit2.Text);
      QBBlockArray[(X div 10)+2,(Y div 10)+1].Color:=DblFillPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)+1].Group:=strtoint(DblFillEdit2.Text);
      QBBlockArray[(X div 10)+1,(Y div 10)+1].Color:=DblFillPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)+1].Group:=strtoint(DblFillEdit2.Text);

      QBBlockArray[(X div 10)+1,(Y div 10)].Color:=DblFillPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)].Group:=strtoint(DblFillEdit2.Text);
      QBBlockArray[(X div 10)+2,(Y div 10)].Color:=DblFillPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)].Group:=strtoint(DblFillEdit2.Text);

      QBBlockArray[(X div 10)+1,(Y div 10)+2].Color:=DblFillPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)+2].Group:=strtoint(DblFillEdit2.Text);
      QBBlockArray[(X div 10)+2,(Y div 10)+2].Color:=DblFillPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)+2].Group:=strtoint(DblFillEdit2.Text);

      QBBlockArray[(X div 10)+1,(Y div 10)-1].Color:=DblFillPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)-1].Group:=strtoint(DblFillEdit2.Text);
      QBBlockArray[(X div 10)+1,(Y div 10)+3].Color:=DblFillPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)+3].Group:=strtoint(DblFillEdit2.Text);

       {The Border  REMEMBER the Y is + = DOWN}
      QBBlockArray[(X div 10)+3,(Y div 10)].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+3,(Y div 10)].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10),(Y div 10)].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10)+2,(Y div 10)-1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)-1].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+3,(Y div 10)-1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+3,(Y div 10)-1].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10),(Y div 10)-1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)-1].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)-1,(Y div 10)-1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)-1,(Y div 10)-1].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10)+2,(Y div 10)-2].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)-2].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+1,(Y div 10)-2].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)-2].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10)+1,(Y div 10)-3].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)-3].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10),(Y div 10)+2].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)+2].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+3,(Y div 10)+2].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+3,(Y div 10)+2].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10),(Y div 10)+3].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)+3].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)-1,(Y div 10)+3].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)-1,(Y div 10)+3].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+2,(Y div 10)+3].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)+3].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+3,(Y div 10)+3].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+3,(Y div 10)+3].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10)+2,(Y div 10)+4].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)+4].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+1,(Y div 10)+4].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)+4].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10)+1,(Y div 10)+5].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)+5].Group:=GroupListBox.ItemIndex;
    end else
    begin
      QBBlockArray[(X div 10),(Y div 10)+1].Color:=DblFillPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)+1].Group:=strtoint(DblFillEdit2.Text);
      QBBlockArray[(X div 10)+2,(Y div 10)+1].Color:=DblFillPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)+1].Group:=strtoint(DblFillEdit2.Text);
      QBBlockArray[(X div 10)+1,(Y div 10)+1].Color:=DblFillPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)+1].Group:=strtoint(DblFillEdit2.Text);

      QBBlockArray[(X div 10),(Y div 10)].Color:=DblFillPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)].Group:=strtoint(DblFillEdit2.Text);
      QBBlockArray[(X div 10)+1,(Y div 10)].Color:=DblFillPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)].Group:=strtoint(DblFillEdit2.Text);

      QBBlockArray[(X div 10)+1,(Y div 10)+2].Color:=DblFillPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)+2].Group:=strtoint(DblFillEdit2.Text);
      QBBlockArray[(X div 10),(Y div 10)+2].Color:=DblFillPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)+2].Group:=strtoint(DblFillEdit2.Text);

      QBBlockArray[(X div 10)+1,(Y div 10)-1].Color:=DblFillPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)-1].Group:=strtoint(DblFillEdit2.Text);
      QBBlockArray[(X div 10)+1,(Y div 10)+3].Color:=DblFillPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)+3].Group:=strtoint(DblFillEdit2.Text);
       {The Border  REMEMBER the Y is + = DOWN}
      QBBlockArray[(X div 10)-1,(Y div 10)].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)-1,(Y div 10)].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+2,(Y div 10)].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10)+2,(Y div 10)-1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)-1].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+3,(Y div 10)-1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+3,(Y div 10)-1].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10),(Y div 10)-1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)-1].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)-1,(Y div 10)-1].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)-1,(Y div 10)-1].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10),(Y div 10)-2].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)-2].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+1,(Y div 10)-2].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)-2].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10)+1,(Y div 10)-3].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)-3].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10)-1,(Y div 10)+2].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)-1,(Y div 10)+2].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+2,(Y div 10)+2].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)+2].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10),(Y div 10)+3].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)+3].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)-1,(Y div 10)+3].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)-1,(Y div 10)+3].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+2,(Y div 10)+3].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+2,(Y div 10)+3].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+3,(Y div 10)+3].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+3,(Y div 10)+3].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10),(Y div 10)+4].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10),(Y div 10)+4].Group:=GroupListBox.ItemIndex;
      QBBlockArray[(X div 10)+1,(Y div 10)+4].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)+4].Group:=GroupListBox.ItemIndex;

      QBBlockArray[(X div 10)+1,(Y div 10)+5].Color:=ColorPanel.Color;
      QBBlockArray[(X div 10)+1,(Y div 10)+5].Group:=GroupListBox.ItemIndex;
    end;
  end;
  PaintAllQBBlocks;
end;

procedure TCatWinForm.ClearQBBtnClick(Sender: TObject);
var x,y:integer;
begin
    For X:=1 to 7 do
    For Y:= 1 to 13 do
    Begin
    QBBlockArray[X,Y].Group:=GroupListBox.ItemIndex;
    QBBlockArray[X,Y].Color:=ColorPanel.Color;
    End;
  PaintAllQBBlocks;
end;

procedure TCatWinForm.QbSaveBtnClick(Sender: TObject);
var
  Layers,X,Y:Integer;
  F: TextFile;
  S: string;
begin
  SaveDialog1.InitialDir :=ImagePath;
  SaveDialog1.Filter :='*.txt';
  if SaveDialog1.Execute then
  begin
  GroupListBox.ItemIndex:=0;
  Application.ProcessMessages;
  AssignFile(F, ChangeFileExt(SaveDialog1.Filename,'.txt'));
  Rewrite(F);
  S:='Quilt Blocks';
  Writeln(F, S);

  If WithColorsCB.Checked then
     S:='With Colors' else S:='';
  Writeln(F, S);
  If WithColorsCB.Checked then
  begin
    S:=AddEdit.Text;
    Writeln(F, S);
    s:=inttostr(BackgroundPanel.Color);
    Writeln(F, S);
    Layers:=GroupListBox.Items.Count;
    s:=inttostr(Layers);
    Writeln(F, S);

    For x:=0 to Layers-1 do
    begin
      s:=(GroupListBox.Items[x]);
      Writeln(F, S);
      s:=(CatList[x]);
      Writeln(F, S);
    end;
  end;

    For X:=1 to 7 do
    For Y:= 1 to 13 do
    Begin
      s:=inttostr(QBBlockArray[X,Y].Group);
      Writeln(F, S);
      s:=inttostr(QBBlockArray[X,Y].Color);
      Writeln(F, S);
    End;
  CloseFile(F);
  end;
end;

procedure TCatWinForm.QBLoadBtnClick(Sender: TObject);
var
  Layers,X,Y:Integer;
  F: TextFile;
  S: string;
begin
  OpenDialog1.InitialDir :=ImagePath;
  OpenDialog1.Filter :='*.txt';
  {OpenDialog1 path, filename, file types :
   FIRST LINE is the switch to ID as what type Quilt Pattern it is}
  if OpenDialog1.Execute then          { Display Open dialog box }
  begin
    Application.ProcessMessages;
    ImagePath:=ExtractFilePath(OpenDialog1.FileName);
    AssignFile(F, OpenDialog1.FileName);   { File selected in dialog box }
    Reset(F);
    Readln(F, S);    { Read the first line out of the file to determine type}
    if (S='Quilt Blocks') then {Set a Switch}
    begin end else
    begin
      Showmessage('Mot a Quilt Blocks file');
      CloseFile(F);
      Exit;{dont do any more}
    end;
    Readln(F, S); if (S='With Colors') then
    WithColorsCB.Checked:=True else WithColorsCB.Checked:=False;
    If WithColorsCB.Checked then
    begin
    Readln(F, S);
    AddEdit.Text := S;     { Put string in a TEdit control }
    Readln(F, S);
    BackgroundPanel.Color:=strtoint(s);
    Readln(F, S);
    Layers:=Strtoint(S);
    {BlockArray: Array [1..19,1..49] of TBlock;}
    GroupListBox.Clear;
    CatList.Clear;
    For x:=0 to Layers-1 do
    begin
      Readln(F, S);
      GroupListBox.Items.Add(S);
      Readln(F, S);
      CatList.Add(S);
    end;
    GroupListBox.ItemIndex:=0;
    ColorPanel.Color:=strtoint(CatList[0]);
    end;

    For X:=1 to 7 do    {7}
    For Y:= 1 to 13 do    {7}
    Begin
      Readln(F, S);
      QBBlockArray[X,Y].Group:=strtoint(S);
      Readln(F, S);
      QBBlockArray[X,Y].Color:=strtoint(S);
    End;
    CloseFile(F);
    Save1.Enabled:=True;
    SaveDialog1.FileName:=OpenDialog1.FileName;
    PaintAllQBBlocks;
  end;
end;

procedure TCatWinForm.PaintQuiltBlocksBtnClick(Sender: TObject);
var Xoffset, Yoffset:Integer;
Procedure BlockPainter(Xoffset, Yoffset:Integer);
var x,y:Integer;
Begin
  //  BlockArray: Array [1..19,1..49] of TBlock;
  //  QBBlockArray: Array [1..7,1..13] of TBlock;
  //3 Wide  4 Tall   3x7=21    4x7=28
  //x190  y490
  //1..7 7..13  13..19
  //1..13  13..25  25..37 37..49
  //  For X:=1 to 19 do  {18 ..36}For Y:= 1 to 49 do    {48}
    For X:=Xoffset to Xoffset+6 do     //7 .. 6or7
    For Y:= Yoffset to Yoffset+12 do   //13..  12
    Begin
      BlockArray[X,Y].Group:=
        QBBlockArray[((X-Xoffset)+1),((Y-Yoffset)+1)].Group;
      BlockArray[X,Y].Color:=
        QBBlockArray[((X-Xoffset)+1),((Y-Yoffset)+1)].Color;
    End;
end;
begin
//ImageQB321  QBCB1
  If QBCB1.Checked then
  begin
  //Set the X,Y Offset and call the BlockPainter
  Xoffset:=1; Yoffset:=1;  BlockPainter(Xoffset,Yoffset);
  end;
  If QBCB2.Checked then
  begin
  //Set the X,Y Offset and call the BlockPainter
  Xoffset:=7; Yoffset:=1;  BlockPainter(Xoffset,Yoffset);
  end;
  If QBCB3.Checked then
  begin
  //Set the X,Y Offset and call the BlockPainter
  Xoffset:=13; Yoffset:=1;  BlockPainter(Xoffset,Yoffset);
  end;

  If QBCB4.Checked then
  begin
  //Set the X,Y Offset and call the BlockPainter
  Xoffset:=1; Yoffset:=13;  BlockPainter(Xoffset,Yoffset);
  end;
  If QBCB5.Checked then
  begin
  //Set the X,Y Offset and call the BlockPainter
  Xoffset:=7; Yoffset:=13;  BlockPainter(Xoffset,Yoffset);
  end;
  If QBCB6.Checked then
  begin
  //Set the X,Y Offset and call the BlockPainter
  Xoffset:=13; Yoffset:=13;  BlockPainter(Xoffset,Yoffset);
  end;

  If QBCB7.Checked then
  begin
  //Set the X,Y Offset and call the BlockPainter
  Xoffset:=1; Yoffset:=25;  BlockPainter(Xoffset,Yoffset);
  end;
  If QBCB8.Checked then
  begin
  //Set the X,Y Offset and call the BlockPainter
  Xoffset:=7; Yoffset:=25;  BlockPainter(Xoffset,Yoffset);
  end;
  If QBCB9.Checked then
  begin
  //Set the X,Y Offset and call the BlockPainter
  Xoffset:=13; Yoffset:=25;  BlockPainter(Xoffset,Yoffset);
  end;

  If QBCB10.Checked then
  begin
  //Set the X,Y Offset and call the BlockPainter
  Xoffset:=1; Yoffset:=37;  BlockPainter(Xoffset,Yoffset);
  end;
  If QBCB11.Checked then
  begin
  //Set the X,Y Offset and call the BlockPainter
  Xoffset:=7; Yoffset:=37;  BlockPainter(Xoffset,Yoffset);
  end;
  If QBCB12.Checked then
  begin
  //Set the X,Y Offset and call the BlockPainter
  Xoffset:=13; Yoffset:=37;  BlockPainter(Xoffset,Yoffset);
  end;
  //Paint the MAIN Blocks per THIS Square Set
  PaintAllBlocks;
end;
///////////////////////////////////////////////////
///////////////////////////////////////////////////
procedure TCatWinForm.PaintAllQBBlocks;
var
  x,y:Integer;
  TempBitmap:TBitmap;
begin
  TempBitmap := TBitMap.Create;
  TempBitmap.Width:=ImageQB321.Width;
  TempBitmap.Height:=ImageQB321.Height;
  TempBitmap.Canvas.Brush.Style := bsSolid;
  TempBitmap.Canvas.Pen.Width:=1;
  ImgView321.Color :=BackgroundPanel.Color;
  For X:=0 to 6 do    //7{0 to 18  19}
  For Y:= 0 to 12 do  //13{0 to 48  49}
  begin
    TempBitmap.Canvas.Brush.Color := QBBlockArray[X+1,Y+1].Color;
    if ((y mod 2) =0) then
    TempBitmap.Canvas.Ellipse(
     (X*10)+1,
     (Y*10)+1,
     ((X+1)*10)-1,
     ((Y+1)*10)-1) else
    TempBitmap.Canvas.Ellipse(
     (X*10)-3,
     (Y*10)+1,
     ((X+1)*10)-5,
     ((Y+1)*10)-1);
  end;
    TempBitmap.Canvas.Pen.Width:=8;
    TempBitmap.Canvas.Pen.Color :=BackgroundPanel.Color;
    TempBitmap.Canvas.Moveto(0,0);
    TempBitmap.Canvas.Lineto(70,0);
    TempBitmap.Canvas.Moveto(70,0);
    TempBitmap.Canvas.Lineto(70,130);
    TempBitmap.Canvas.Moveto(70,130);
    TempBitmap.Canvas.Lineto(0,130);
    TempBitmap.Canvas.Pen.Width:=2;
    TempBitmap.Canvas.Moveto(0,130);
    TempBitmap.Canvas.Lineto(0,0);
    ImageQB321.Bitmap.Assign(TempBitmap);
    TempBitmap.Free;
end;
///////////////////////////////////////////////////
///////////////////////////////////////////////////


///////////////////////////////////////////////////
///////////////////////////////////////////////////
procedure TCatWinForm.ColorsClearBtnClick(Sender: TObject);
begin
  GroupListBox.Clear;
  CatList.Clear;
  AddEdit.Text:='Silver';
  GroupListBox.Items.Add(AddEdit.Text);
  CatList.Add(Inttostr(clSilver));
  GroupListBox.ItemIndex:=0;
  ColorPanel.Color:=clSilver;
end; 


procedure TCatWinForm.ColorsSaveBtnClick(Sender: TObject);
var
  Layers,X:Integer;
  F: TextFile;
  S: string;
begin
  SaveDialog1.InitialDir :=ImagePath;
  SaveDialog1.Filter :='*.txt';
  if SaveDialog1.Execute then
  begin
  GroupListBox.ItemIndex:=0;
  Application.ProcessMessages;
  AssignFile(F, ChangeFileExt(SaveDialog1.Filename,'.txt'));
  Rewrite(F);
  S:='Quilt Colors';
  Writeln(F, S);

    S:=AddEdit.Text;
    Writeln(F, S);
    s:=inttostr(BackgroundPanel.Color);
    Writeln(F, S);
    Layers:=GroupListBox.Items.Count;
    s:=inttostr(Layers);
    Writeln(F, S);

    For x:=0 to Layers-1 do
    begin
      s:=(GroupListBox.Items[x]);
      Writeln(F, S);
      s:=(CatList[x]);
      Writeln(F, S);
    end;
  CloseFile(F);
  end;
end;


procedure TCatWinForm.ColorsLoadBtnClick(Sender: TObject);
var
  Layers,X:Integer;
  F: TextFile;
  S: string;
begin
  OpenDialog1.InitialDir :=ImagePath;
  OpenDialog1.Filter :='*.txt';
  {OpenDialog1 path, filename, file types :
   FIRST LINE is the switch to ID as what type Quilt Pattern it is}
  if OpenDialog1.Execute then          { Display Open dialog box }
  begin
    Application.ProcessMessages;
    ImagePath:=ExtractFilePath(OpenDialog1.FileName);
    AssignFile(F, OpenDialog1.FileName);   { File selected in dialog box }
    Reset(F);
    Readln(F, S);    { Read the first line out of the file to determine type}
    if (S='Quilt Colors') then {Set a Switch}
    begin end else
    begin
      Showmessage('Mot a Quilt Colors file');
      CloseFile(F);
      Exit;{dont do any more}
    end;
    Readln(F, S);
    AddEdit.Text := S;     { Put string in a TEdit control }
    Readln(F, S);
    BackgroundPanel.Color:=strtoint(s);
    Readln(F, S);
    Layers:=Strtoint(S);
    {BlockArray: Array [1..19,1..49] of TBlock;}
    GroupListBox.Clear;
    CatList.Clear;
    For x:=0 to Layers-1 do
    begin
      Readln(F, S);
      GroupListBox.Items.Add(S);
      Readln(F, S);
      CatList.Add(S);
    end;
    GroupListBox.ItemIndex:=0;
    ColorPanel.Color:=strtoint(CatList[0]);
    CloseFile(F);
    SaveDialog1.FileName:=OpenDialog1.FileName;
  end;
end;






end.
